
#----------------------------------------------------------------------
#                    LunarNight Lab. Common Design System
#                    UpdateForm Generator
#----------------------------------------------------------------------

return 1;

sub generate{
	
	($exec_design,*opt_p,$d_opt) = @_;
	
	if ($design_set != 1){ return(&error('no_init'));}
	
	#---pt@C擾
	$conf_file = $d_path.$exec_design.".conf";
	$conf_file = $d_opt .$exec_design.".conf" if $d_opt ne "";
	
	$textopt  = $opt_p{"textopt" };
	$titleopt = $opt_p{"titleopt"};
	$tableopt = $opt_p{"tableopt"};
	
	#---ϐ
	$out_table   = "";
	$tmp         = "";
	$before      = "";
	$update_str  = "";
	$tx_flag     = 0;
	
	if (! open(CONF,$conf_file)){ return(&error("read",'ݒt@C'));}
	binmode CONF;
	
	$out_table = "<table $tableopt><tr><td><table>\n";
	while(<CONF>){
		$_ =~ s/\r//;
		&jcode'convert(*_,"euc");
		
		if ($_ =~ /^\#\-+[^\-]+\-+\#\n/  ){
			
			if ($tmp ne ""){ $out_table .= "<tr><td colspan=3></td><td><pre>$tmp</pre></td></tr>\n"; $tmp="";}
			
			($title) = $_ =~ /^\#\-+([^\-]+)\-+\#\n/;
			$out_table .= "</table></td></tr></table>\n<table $tableopt><tr><td $titleopt>$title</td></tr>\n<tr><td><table $tableopt>\n";
			next;
		}
		if ($_ =~ /^\w+\s*=\s*\"[^\"]*\"/){
			
			if ($tmp ne ""){ $out_table .= "<tr><td colspan=3></td><td><pre>$tmp</pre></td></tr>\n"; $tmp="";}
			
			($key,$val) = $_ =~ /^(\w+)\s*=\s*\"([^\"]*)\"/;
			($msg,@opt) = split(/\|/,$');
			$msg =~ s/\#-*(\d*)\-*\s*//;
			if   ($1 eq "0"){ next;}
			elsif($1 ne "" ){ $dsp_size = $1+1;          }
			else            { $dsp_size = length($val)+2;}
			$msg =~ s/^\s*//;
			$msg =~ s/\s*$//;
			$opt2= join("|",@opt);
			$opt2=~ s/\//<br>\n/g;
			
			#---IvV
			$optlist = "";
			$opt2 =~ s/\(([^\)]+)\)(\-*)//;
			$orlist  = $1;
			$oropt   = $2;
			
			$opt2 =~ s/\[([^\]]+)\](\-*)//;
			$andlist = $1;
			$andopt  = $2;
			
			$tmp2 = "main::$key";
			
			($cls,$optlist) = &option_analyze($orlist,$andlist,$$tmp2,$key,$andopt,$oropt);
			$optlist = "<td><input name=$key type=text value=\"$$tmp2\" size=$dsp_size $textopt></td>" if $optlist eq "";
			$update_str .= $key."-";
			
			if ($msg eq ""){ next;}
			$out_table .= "<tr><td nowrap>$msg</td><td>F</td>$optlist<td>$opt2</td></tr>\n" if $cls eq "";
			$out_table .= "<tr><td nowrap>$msg</td><td>F</td>$optlist</tr>\n<tr><td colspan=2></td><td colspan=$cls align=center>$opt2</td></tr>\n" if $cls ne "";
			
			next;
		}
		if (substr($_,0,4) eq "TEXT"){
			$txflag = 1;
			$tx_com = substr($before,4);
			$tx_name= substr($_,6);
			chomp($tx_name);
			$tx_name2= "main::$tx_name";
		}
		if (substr($_,0,5) eq "TXEND" && $txflag == 1){
			($tx_com,$tx_com2) = split(/-/,$tx_com);
			$tx_com2 =~ s/\//<br>/g;
			$update_str .= $tx_name."-";
			$out_table .= "<tr><td nowrap valign=top>$tx_com</td><td valign=top>F</td><td valign=top><textarea name=$tx_name $textopt cols=30 rows=5>$$tx_name2</textarea></td><td valign=top>$tx_com2</td></tr>\n";
			$txflag = 0;
		}
		if ($txflag == 1){
			$tx_dat .= $_;
		}
		
		if ($_ =~ /^\s+\#/){
			$tmp .= $';
			next;
		}
		if ($_ eq "\n"){
			
			if ($tmp ne ""){ $out_table .= "<tr><td colspan=3></td><td><pre>$tmp</pre></td></tr>\n"; $tmp="";}
			
			$out_table .= "<tr><td colspan=4><br></td></tr>\n";
			next;
		}
		$before = $_;
	}
	close(CONF);
	$out_table .= "<input type=hidden value=$update_str name=update_ctl></table></td></tr></table>\n";
	
	return(*out_table);
	
}


sub option_analyze{
	
	($t_or,$t_and,$def_val,$key_p,$a_opt,$o_opt) = @_;
	
	$out_data = "";
	$cls      = "";
	
	if ($t_or ne ""){
		
		%def_hash = ();
		foreach $x (split(/ /,$def_val)){
			$def_hash{$x} = 1;
		}
		
		@xitem = split(/\s+or\s+/,$t_or);
		$out_data .= "<td nowrap align=right colspan=2><pre>" if $o_opt eq "-";
		foreach $x (@xitem){
			($k,$v) = split(/=/,$x);
			$v = $k if $v eq "";
			
			if ($def_hash{$k} == 1){ $chk_tmp = "checked";}else{ $chk_tmp = "";}
			$out_data .= "<td nowrap align=right>$v<input type=radio $chk_tmp name=$key_p value=\"$k\"></td>\n" if $o_opt ne "-";
			$out_data .= "$v<input type=radio $chk_tmp name=$key_p value=\"$k\">  " if $o_opt eq "-";
		}
		$out_data .= "</pre></td>" if $o_opt eq "-";
		
		$cls = $#xitem+1;
	}elsif($t_and ne ""){
		
		%def_hash = ();
		foreach $x (split(/ /,$def_val)){
			$def_hash{$x} = 1;
		}
		
		@xitem = split(/\s+/,$t_and);
		$out_data .= "<td nowrap align=right colspan=4><pre>" if $a_opt eq "-";
		foreach $x (@xitem){
			($k,$v) = split(/=/,$x);
			$v = $k if $v eq "";
			
			if ($def_hash{$k} == 1){ $chk_tmp = "checked";}else{ $chk_tmp = "";}
			
			$out_data .= "<td nowrap align=right>$v<input type=checkbox $chk_tmp name=$key_p value=\"$k\"> </td>\n" if $a_opt ne "-";
			$out_data .= "$v<input type=checkbox $chk_tmp name=$key_p value=\"$k\">  " if $a_opt eq "-";
		}
		$out_data .= "</pre></td>" if $a_opt eq "-";
		$cls = $#xitem+1;
	}
	
	return($cls,$out_data);
	
}
