#-------------------------------------------------------------------------------------------------------
# Imap4OC
# &imap4login(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           None                   imap_server   --- IMAP Server
#                                  imap_port     --- IMAP Port
#                                  imap_account  --- IMAP Account
#                                  imap_password --- IMAP Password
#                                  imap_ssl      --- IMAP over SSL (ssl|"")
# Output: 1 | ErrNum
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub imap4login{
	
	#---e擾
	my($lib_pf,$lib_cf) = @_;
	*lib_ip = $lib_pf;
	*lib_cp = $lib_cf;
	
	
	$imap_server   = $lib_cp{"imap_server"  };
	$imap_port     = $lib_cp{"imap_port"    };
	$imap_account  = $lib_cp{"imap_account" };
	$imap_password = $lib_cp{"imap_password"};
	$imap_ssl      = $lib_cp{"imap_ssl"     };

	#---SpecialBoxZbg
	($rc,$inbox2,$errmsg) = &execute('imap4specialbox',"set",$lib_cf);
	if ($rc ne "1"){ return('imap4login->'.$rc,$inbox2,$errmsg);}
	
	
	#---IMAP4͈ʓI143ԃ|[g
	if ($imap_port eq ""){ $imap_port = "143";}
	
	#----IMAP4 ւ TCP/IP ڑ
	if ($imap_ssl eq "1"){
		($rc,$type,$msg) = &execute('open_ssl_connection',$imap_server,$imap_port,'IMAP4');
		$imap_ssl_flag = 1;
	}else{
		($rc,$type,$msg) = &execute('open_tcp_connection',$imap_server,$imap_port,'IMAP4');
		$imap_ssl_flag = 0;
	}
	if ($rc ne "1"){ return('imap4login->'.$rc,$type,$msg);}
	
	#-----Ready ?
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError (Server not ready)";}
	$rc = &imap4_rc();
#	if( substr($rc,0,4) ne "* OK" ) { &execute("imap4logout");
#	                                  return(-32);            }
	
	#---T[o[Xe[^X
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError (TimeOutError: CAPABILITY Command)";}
	($rc,$out) = &imap4_com("CAPABILITY");
	if (substr($rc,0,2) ne "OK"){ &execute("imap4logout");
	                              return('imap4login','capability',$rc."\n".$out);}
	
	$login_mode = 0;
	if (index($out,"AUTH=CRAM-MD5") >= 0){ $login_mode = 1;}
	if ($imap_ssl_flag == 1             ){ $login_mode = 0;}
	
	#---LOGIN
	if ($login_mode == 1){
		&imap4_tr("0000 AUTHENTICATE CRAM-MD5\r\n");
		$rc = &imap4_rc();
		@item = split(/\s/,$rc);
		$challenge = $item[$#item];
		
		($rc,$res_key) = &execute('sasl','cram-md5',$imap_account,$imap_password,$challenge);
		
		&imap4_tr($res_key."\r\n");
		$rc = &imap4_rc();
		if (substr($rc,0,7) ne "0000 OK"){ $login_mode = 0;}
	}
	if ($login_mode == 0){
		($rc,$out) = &imap4_com("LOGIN $imap_account $imap_password");
		if (substr($rc,0,2) ne "OK"){ &execute("imap4logout");
		                              return('imap4login','login',$rc."\n".$out);}
	}
	
	$login_ctl{"imap"} = 1;
	
	return(1);
	
}
