#-------------------------------------------------------------------------------------------------------
# [{bNXڕۑ
# &imap4append(<Pointer>,<ConfigPointer>);
# Input: <Pointer> HashPointer                               <ConfigPointer> HashPointer
#         => msg_file = <MessageFile>                         => imap_server   -- IMAP Server
#            into     = <MailBox>                                imap_port     -- IMAP Port
#                                                                imap_password -- IMAP Password
#                                                                imap_account  -- IMAP Account
#                                                                imap_ssl      -- IMAP over SSL
#-------------------------------------------------------------------------------------------------------

return 1;

sub imap4append{
	
	#---e擾
	my($lib_f,$lib_cf) = @_;
	my $flags = "";
	*lib_p = $lib_f;
	
	my $into_box = $lib_p{"into"      };
	my $msg_data = $lib_p{"msg_data"  };
	my $delimit_f= $lib_p{"getdelimit"};
	my $readflag = $lib_p{"readflag"  };
	
	if ($into_box eq ""){ return('imap4append','nombox','MailBox'  );}
	if ($msg_data eq ""){ return('imap4append','nomsg' ,'AppendMsg');}
	
	$flags    = "(\\Seen) " if $readflag eq "1";
	$msg_data =~ tr/\r//d;
	$msg_data =~ s/\n/\r\n/g;
	my $size  = length($msg_data);
	
	if($delimit_f ne ""){
		my($rc,$sendbox) = &execute('imap4specialbox','get','send');
		if (index($sendbox,"\0") != -1){
			my $send2 = substr($sendbox,0,index($sendbox,"\0")) if index($sendbox,"\0") != -1;
			
			my($rc,$flag,$delimit,$name) = &execute('imap4getdelimit',$send2);
			if ($rc ne "1"){ ($rc,$flag,$delimit,$name) = ('','','','');}
			$into_box =~ s/\Q$delimit_f\E/$delimit/g if $delimit ne "";
		}
	}
	return('imap4append','delimit' ) if index($into_box,"\0") != -1;
	
	#---MJn
	$into_box =~ s/\\\\/\\/g;
	$into_box =~ s/\\/\\\\/g;
	&imap4_tr("0000 APPEND \"$into_box\" $flags\{$size}\r\n");
	my $rc = &imap4_rc();
	if (substr($rc,0,4) eq "0000"){ &execute("imap4logout");
	                                return('imap4append','append',$rc);}
	
	#---bZ[WIDM
	&imap4_tr($msg_id) if $add_id ne "";
	
	&imap4_tr($msg_data);
	&imap4_tr("\r\n");
	$rc = &imap4_rc();
	if (substr($rc,0,7) ne "0000 OK"){ &execute("imap4logout");
	                                   return('imap4append','append',$rc);}
	
	return(1,substr($rc,5));
	
}

