#-------------------------------------------------------------------------------------------------------
#                          mailcontrol.plW[  - EnhancedSMTPZbVm -
#
# Programmed by LunarNight
#-------------------------------------------------------------------------------------------------------

return 1;

sub smtp2{
	
	($smtp_handle) = @_;
	
	#----SMTP ւ TCP/IP ڑ
	if ($smtp_ssl eq "1"){
		($rc,$type,$msg) = &execute('open_ssl_connection',$smtp_server,$smtp_port,'SMTP');
		$smtp_ssl_flag = 1;
	}else{
		($rc,$type,$msg) = &execute('open_tcp_connection',$smtp_server,$smtp_port,'SMTP');
		$smtp_ssl_flag = 0;
	}
	if ($rc ne "1"){ return('smtp2->'.$rc,$type,$msg);}
	
	#---Ready ?
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError (Server not ready)";}
	$rc = &smtp_rc();
	if(substr($rc,0,3) ne "220"){ &execute("closesmtp",1);
	                              return('smtp2','smtpready',$rc);}
	
	#---EHLO
	$version = $main::library_version{"mailcontrol"};
	$title   = $main::library_title{"mailcontrol"};
	$title   =~ s/ /_/g;
	
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError (smtp->helo command)";}
	&smtp_tr("EHLO $title-Ver-$version\r\n");
	$rcx = &smtp_rc();
	if(substr($rcx,0,3) ne "250"){ &execute("closesmtp");
	                              return('smtp2','ehlo',$rcx);}

	
	if($rcx =~ /cram-md5/i){ if (&smtp_connection_cram_md5() == 1){ return(1);}} #---CRAM-MD5F؂gHH
	if($rcx =~ /login/i   ){ if (&smtp_connection_login()    == 1){ return(1);}} #---LOGINF؂gHH
	if($rcx =~ /plain/i   ){ if (&smtp_connection_plain()    == 1){ return(1);}} #---PLAINF؂gHH
	
	#---_Ȃ狭ILOGIN
	$user_tmp  = &main::bodyencode($opt_user,"b64");
	$user_tmp .= &main::benflush();
	$pass_tmp  = &main::bodyencode($opt_pass,"b64");
	$pass_tmp .= &main::benflush();
	$user_tmp =~ tr/\n\r//d;
	$pass_tmp =~ tr/\n\r//d;
	
	&smtp_tr("AUTH LOGIN\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "334"){ &execute("closesmtp");
	                               return('smtp2','smtpauth',$rc);}
	
	&smtp_tr("$user_tmp\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "334"){ &execute("closesmtp");
	                               return('smtp2','smtpauth',$rc);}

	&smtp_tr("$pass_tmp\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "235"){ &execute("closesmtp");
	                               return('smtp2','smtpauth',$rc);}
	
	&smtp_tr("RSET\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "250"){ &execute("closesmtp");
	                               return('smtp2','reset',$rc);   }
	
	return(1);
}


sub smtp_connection_login{
	#---_Ȃ狭ILOGIN
	$user_tmp  = &main::bodyencode($opt_user,"b64");
	$user_tmp .= &main::benflush();
	$pass_tmp  = &main::bodyencode($opt_pass,"b64");
	$pass_tmp .= &main::benflush();
	$user_tmp =~ tr/\n\r//d;
	$pass_tmp =~ tr/\n\r//d;
	
	&smtp_tr("AUTH LOGIN\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "334"){ return(0);}
	
	&smtp_tr("$user_tmp\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "334"){ return(0);}

	&smtp_tr("$pass_tmp\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "235"){ return(0);}
	
	&smtp_tr("RSET\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "250"){ return(0);}
	
	return(1);
}

sub smtp_connection_plain{
	
	($rc,$res_key) = &execute('sasl','plain',$opt_user,$opt_pass);
	
	&smtp_tr("AUTH PLAIN $res_key\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "235"){ return(0);}

	&smtp_tr("RSET\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "250"){ return(0);}

	return(1);
}


sub smtp_connection_cram_md5{
	
	&smtp_tr("AUTH CRAM-MD5\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "334"){ return(0);}
	
	$challenge = substr($rc,4);
	
	($rc,$res_key) = &execute('sasl','cram-md5',$opt_user,$opt_pass,$challenge);

	&smtp_tr("$res_key\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "235"){ return(0);}

	&smtp_tr("RSET\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "250"){ return(0);}

	return(1);

}


