# SJIS
$oneByte_sjis = '[\x00-\x7F\xA1-\xDF]'; # 1oCg SJIS
$twoBytes_sjis =
  '(?:[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC])'; # 2oCg SJIS
$character_sjis = "(?:$oneByte_sjis|$twoBytes_sjis)"; # SJIS

return 1;

sub split_str{
	
	my($read_data,$body_maxstr) = @_;
	my($len,$now,$tmp,$read,$tlen,$err) = (0,0,0,0,0,0);
	my($body,$a,$out) = ('','','');
	
	return($read_data) if $body_maxstr == 0;
	
	foreach $a (split(/\n/,$read_data)){
		$len = length($a);
		if ($len > $body_maxstr){
			$tmp = $err = 0;
			while($tmp < $len){
				$read = $len - $tmp;
				$read = $body_maxstr if $read > $body_maxstr;
				$body   = substr($a,$tmp,$read);
				($body) = $body =~ /^($character_sjis+)/o;
				$tlen = length($body);
				if ($tlen < $read-1 || $tlen == 0){ $err = 1; last;}
				else                              { 
					$tmp += $tlen;
					$out .= $body."\n";
				}
			}
			if ($err == 1){
				$out .= substr($a,$tmp)."\n" if $tmp != 0;
				$out .= $a."\n"              if $tmp == 0;
			}
		}else{
			$out .= $a."\n";
		}
	}
	return($out);
}


