
#-------------------------------------------------------------------------------
#                           jcode⏕Cu
#                           Ver1.3
#
# jcodeƌp邱ƂŁAUTF-8ϊ@\܂
# ܂AMIMEfR[h@\܂
# ϊe[u(euc-utf8-[11,22,23].dat sjis-utf8-[11,13,22,23].dat)Kvł
#
#g
# ŏjcode.plrequireĂI
# AUTF-8<->EUC/SJISϊ݂̂̏ꍇAjcode͕Kv܂B
#
# MIMEfR[h
# &mojicode'mime_dec(\$str,<ϊR[h>);
# <ϊR[h> -- [euc|sjis]
# 
# ʂɕR[hϊ
# &mojicode'convert(\$str,<ϊR[h>,<ϊR[h>
# 
# <ϊR[h>   -- ϊ̕R[h  [jis|sjis|euc|utf-8]
# <ϊR[h> -- ϊO̕R[h  [utf-8|iso-2202-jp|sjis|euc|jis]
# 
# R[hގ擾
# &mojicode'getcode(\$str);
# 
# o - [jis|sjis|euc|utf-8|binary]
# 
# ------------------------------------------------------------------------------
# Copyright 2006
# LunarNight Laboratory
# Home:http://www.ln-lab.net/
# Mail:lunar@ln-lab.net
# 
#E쌠CzzCƐӎ
#
# ̃Cu͒쌠͕܂񂪁At[\tgŁA
# RɉEgݍ݁EzzĂĂ܂܂B
# {vO͗LpƂ͎v܂CЕzɂẮCsꐫyѓړIK
# ɂĂ̈Öق̕ۏ؂܂߂āCȂۏ؂sȂ܂B
# 
# ------------------------------------------------------------------------------

package mojicode;

$mojicode_version = 1.3;

%b64_dec = (
'A', '000000',  'B', '000001',  'C', '000010',  'D', '000011',
'E', '000100',  'F', '000101',  'G', '000110',  'H', '000111',
'I', '001000',  'J', '001001',  'K', '001010',  'L', '001011',
'M', '001100',  'N', '001101',  'O', '001110',  'P', '001111',
'Q', '010000',  'R', '010001',  'S', '010010',  'T', '010011',
'U', '010100',  'V', '010101',  'W', '010110',  'X', '010111',
'Y', '011000',  'Z', '011001',  'a', '011010',  'b', '011011',
'c', '011100',  'd', '011101',  'e', '011110',  'f', '011111',
'g', '100000',  'h', '100001',  'i', '100010',  'j', '100011',
'k', '100100',  'l', '100101',  'm', '100110',  'n', '100111',
'o', '101000',  'p', '101001',  'q', '101010',  'r', '101011',
's', '101100',  't', '101101',  'u', '101110',  'v', '101111',
'w', '110000',  'x', '110001',  'y', '110010',  'z', '110011',
'0', '110100',  '1', '110101',  '2', '110110',  '3', '110111',
'4', '111000',  '5', '111001',  '6', '111010',  '7', '111011',
'8', '111100',  '9', '111101',  '+', '111110',  '/', '111111',
);

$sjis_utf8_11 = './lib/dat/sjis-utf8-11.dat';
$sjis_utf8_13 = './lib/dat/sjis-utf8-13.dat';
$sjis_utf8_22 = './lib/dat/sjis-utf8-22.dat';
$sjis_utf8_23 = './lib/dat/sjis-utf8-23.dat';
$euc_utf8_11  = './lib/dat/euc-utf8-11.dat';
$euc_utf8_22  = './lib/dat/euc-utf8-22.dat';
$euc_utf8_23  = './lib/dat/euc-utf8-23.dat';

#---R[hK\
#$oneUTF8   = '(?:[\x00-\x7F])';
#$utf8_moji = "(?:$oneUTF8|$twoUTF8|$threeUTF8)";
$twoUTF8    = '(?:[\xC0-\xDF][\x80-\xBF])';
$threeUTF8  = '(?:[\xE0-\xEF][\x80-\xBF][\x80-\xBF])';
$utf8_moji  = "(?:$twoUTF8|$threeUTF8)";

$ascii_moji = '\x1b\([BHJ]([\t\x20-\x7e]*)';
$jis_moji   = '\x1b\$[@B](([\x21-\x7e]{2})*)';

$ascii          = '[\x00-\x7F]';                              # 1oCg EUC-JP
$twoBytes_euc   = '(?:[\x8E\xA1-\xFE][\xA1-\xFE])';           # 2oCg EUC-JP
$threeBytes_euc = '(?:\x8F[\xA1-\xFE][\xA1-\xFE])';           # 3oCg EUC-JP
$euc_moji       = "(?:$ascii|$twoBytes_euc|$threeBytes_euc)"; # EUC-JP

$oneByte_sjis  = '[\x00-\x7F\xA1-\xDF]';                         # 1oCg SJIS
$twoBytes_sjis = '(?:[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC])'; # 2oCg SJIS
$sjis_moji     = "(?:$oneByte_sjis|$twoBytes_sjis)";             # SJIS

$re_bin        = '[\000-\006\177\377]';

$uni2sjis_f = 0;
$uni2euc_f  = 0;

%uni2sjis_h =();
%uni2euc_h  =();
%sjis2uni_h =();
%euc2uni_h  =();

return 1;

sub convert{
	my($str_f,$code,$org) = @_;
	
	$code = lc($code);
	$org  = lc($org);
	
	$org  = '' if $org ne 'sjis' && $org ne 'euc' && $org ne 'utf-8' && $org ne 'jis' && $org ne 'iso-2022-jp';
	$org  = &getcode($str_f) if $org eq '';
	
	if ($code eq 'utf-8'){
		if ($org eq 'iso-2022-jp' ||
		    $org eq 'jis'){ &jcode'convert($str_f,'sjis','jis'); $org = 'sjis'; }

		if ($org eq 'sjis'){
			&init('sjis');
			$$str_f =~ s/($sjis_moji)/$sjis2uni_h{$1}/og;
		}elsif($org eq 'euc'){
			&init('euc');
			$$str_f =~ s/($euc_moji)/$euc2uni_h{$1}/og;
		}
	}elsif($code eq 'euc'){
		if ($org eq 'utf-8'){
			&init('euc');
			$$str_f =~ s/($utf8_moji)/$uni2euc_h{$1}/og;
		}elsif($org eq 'sjis'){
			&jcode'convert($str_f,'euc','sjis');
		}elsif($org eq 'jis' || $org eq 'iso-2022-jp'){
			&jcode'convert($str_f,'euc','jis');
		}
	}elsif($code eq 'sjis'){
		if ($org eq 'utf-8'){
			&init('sjis');
			$$str_f =~ s/($utf8_moji)/$uni2sjis_h{$1}/og;
		}elsif($org eq 'euc'){
			&jcode'convert($str_f,'sjis','euc');
		}elsif($org eq 'jis' || $org eq 'iso-2022-jp'){
			&jcode'convert($str_f,'sjis','jis');
		}
	}elsif($code eq 'jis' || $code eq 'iso-2022-jp'){
		if ($org eq 'utf-8'){
			&init('sjis');
			$$str_f =~ s/($utf8_moji)/$uni2sjis_h{$1}/og;
			$org = 'sjis';
		}
		
		if($org eq 'euc'){
			&jcode'convert($str_f,'jis','euc');
		}elsif($org eq 'sjis'){
			&jcode'convert($str_f,'jis','sjis');
		}
	}
}

sub mime_dec{
	
	my($str_f,$code) = @_;
	
	$$str_f =~ s/=\?([^\?]+)\?([^\?]+)\?([^\?]+)\?=/&mime_sub($1,$2,$3,$code)/eg;
	
}
sub mime_sub{
	my($type,$enc,$dat,$code) = @_;
	
	$enc = lc($enc);
	$type= lc($type);
	$type=~ tr/_/-/;
	
	if ($enc eq "b"){ #---Base64
#		$dat =~ s/\=+$//;
		$dat =~ s/(.)/$b64_dec{$1}/g;
#		$dat = join('', @b64_dec{split(//, $dat)});
		$dat = pack("B".(length($dat)>>3<<3), $dat);
	}else{                #---Quoted-Printable
		$dat =~ s/=([0-9A-Fa-f]{2})/pack("C",hex($1))/ge;
	}
	
	if   ($type eq 'iso-2022-jp'){
		&jcode'convert(\$dat,$code,'jis');
	}elsif($type eq 'shift-jis'){
		&jcode'convert(\$dat,$code,'sjis');
	}elsif($type eq 'euc-jp'){
		&jcode'convert(\$dat,$code,'euc');
	}elsif($type eq 'utf-8'      ){ 
		if ($code eq "sjis"){
			&init('sjis');
			$dat =~ s/($utf8_moji)/$uni2sjis_h{$1}/og;
		}else{
			&init('euc');
			$dat =~ s/($utf8_moji)/$uni2euc_h{$1}/og;
		}
	}
	return($dat);
}

sub init{
	
	my($moji) = @_;
	
	return(0) if $moji eq 'sjis' && $uni2sjis_f eq '1';
	return(0) if $moji eq 'euc'  && $uni2euc_f  eq '1';
	
	my @dat;
	my $max;
	my($hash1_f,$hash2_f);
	
	if ($moji eq 'sjis'){
		@dat = ($sjis_utf8_11,1,1,2,
		        $sjis_utf8_13,1,3,4,
		        $sjis_utf8_22,2,2,4,
		        $sjis_utf8_23,2,3,5);
		$max = 4;
		$uni2sjis_f = '1';
		$hash1_f = \%uni2sjis_h;
		$hash2_f = \%sjis2uni_h;
	}elsif($moji eq 'euc'){
		@dat = ($euc_utf8_11,1,1,2,
		        $euc_utf8_22,2,2,4,
		        $euc_utf8_23,2,3,5);
		$max = 3;
		$uni2euc_f = '1';
		$hash1_f = \%uni2euc_h;
		$hash2_f = \%euc2uni_h;
	}

	my $a;
	my($buf,$t,$uni);
	foreach $a (1.. $max){
		my $fname     =shift(@dat);
		my $tsize     =shift(@dat);
		my $usize     =shift(@dat);
		my $totalsize =shift(@dat);
		
		open(IN,$fname);
		binmode IN;
		my $db_size = -s $fname;
		my $size = 0;
		while($size <= $db_size){
			read(IN,$buf,$totalsize);
			$t   = substr($buf,0,$tsize);
			$uni = substr($buf,$tsize,$usize);
			$size += $totalsize;
			$$hash1_f{$uni} = $t;
			$$hash2_f{$t  } = $uni;
		}
		close(IN);
	}
	return(1);
}

sub getcode {
	my($s_f) = @_;
	my($matched, $code);

	if ($$s_f !~ /[\e\200-\377]/) {                # {ꕶ
		$matched = 0;
		$code = undef;
		
	}elsif ($$s_f =~ /$jis_moji/o) {               # JIS
		$matched = 1;
		$code = 'jis';
		
	}elsif ($$s_f =~ /$re_bin/o) {                 # oCi
		$matched = 0;
		$code = 'binary';
	
	}else{                                         # EUC/SJIS/UTF8̂ǂꂩ
		my($sjis,$euc,$utf8) = (0,0,0);
	
		while ($$s_f =~ /((?:$twoBytes_sjis)+)/go){
			$sjis += length($1);
		}
		while ($$s_f =~ /((?:$twoBytes_euc|$threeBytes_euc)+)/go) {
			$euc  += length($1);
		}
		while ($$s_f =~ /((?:$twoUTF8|$threeUTF8)+)/go) {
			$utf8  += length($1);
		}
		$code    = 'sjis';
		$matched = $sjis;
		
		if ($matched == $euc ){ return('');}
		if ($matched < $euc ){ $code = 'euc';   $matched = $euc; }
		if ($matched == $utf8){ return('');}
		if ($matched < $utf8){ $code = 'utf-8'; $matched = $utf8;}

	}
	return($code);
}

