
$lib_info {"encrypt"} = "DES Encrypt Support Package";
$lib_com  {"encrypt"} = "DESÍT|[gpbP[W";
$lib_ver  {"encrypt"} = "2.0";
$lib_maker{"encrypt"} = "LunarNight";

package encrypt;

#-------------------------------------------------------------------------------
#                           DESÍT|[gpbP[W
#                           Ver1.0
# 
# pX[hÍsꍇ
# md5.plAdes.pl[hĂ
#
#-------------------------------------------------------------------------------
return 1;

package des_crypt;

sub main::encrypt{
	
	($e_mode,$value,$opt) = @_;
	
	if    ($e_mode eq "encrypt" ){ return(&des_crypt  ($value,$opt));}
	elsif ($e_mode eq "set_seed"){ return(&des_setseed($value));     }
	elsif ($e_mode eq "decrypt" ){ return(&des_decrypt($value,$opt));}
	elsif ($e_mode eq "set_pass"){ return(&des_setpass($value));     }
	
}

sub des_setseed{
	
	($value) = @_;
	
	@crypt_key =  &des::des_set_key(pack("H*",$value));
	
}

sub des_crypt{
	
	($value,$opt) = @_;
	
	$value   = &md5::convert($value).$value;
	$out_len = 8 - (length($value) % 8);
	$value   = $out_len.$value;
	
	$str = "";
	
	$cnt = int(length($value) / 8);
	$cnt -- if length($value) % 8 == 0;
	
	if ($opt eq 'b64'){
		foreach $a (0.. $cnt){
			$str .= &des::des_ecb_encrypt(*crypt_key,1,substr($value,$a*8,8));
		}
		$str  = &main::bodyencode($str);
		$str .= &main::benflush();
		$str  =~ s/\n/\|/g;
	}else{
		foreach $a (0.. $cnt){
			$str .= unpack("H*",&des::des_ecb_encrypt(*crypt_key,1,substr($value,$a*8,8)));
		}
	}
	
	return($str);
}

sub des_decrypt{
	
	($value,$opt) = @_;
	
	$str = "";
	if ($opt eq 'b64'){
		$value =~ s/\|/\n/g;
		$value  = &main::bodydecode($value);
		$value .= &main::bdeflush();
		$cnt = int(length($value) / 8)-1;
		foreach $a (0.. $cnt){
			$str .= &des::des_ecb_encrypt(*crypt_key,0,substr($value,$a*8,8));
		}
	}else{
		$cnt = int(length($value) / 16)-1;
		foreach $a (0.. $cnt){
			$str .= &des::des_ecb_encrypt(*crypt_key,0,pack("H*",substr($value,$a*16,16)));
		}
	}
	
	
	#---f[^`FbN
	$out_len  = substr($str,0,1 );
	$md5_hash = substr($str,1,16);
	$out_data = substr($str,17,length($str)-16-$out_len);
	$md5_now  = &md5::convert($out_data);
	
	if ($md5_now ne $md5_hash){ return(0,'ERROR:Ɏs܂');}
	
	return(1,$out_data);
	
}

sub des_setpass{
	
	($value) = @_;
	
	if (substr($value,0,1) eq "\\"){ $value = substr($value,1);     }
	else                           { $value = &md5::convert($value);
	                                 $value = unpack("H*",$value);  }
	
	&des_setseed($value);
	
	return($value);
}

