
$lib_info {'encrypt'} = 'DES Encrypt Support Package';
$lib_com  {'encrypt'} = 'DESÍT|[gpbP[W';
$lib_ver  {'encrypt'} = '2.0';
$lib_maker{'encrypt'} = 'LunarNight';

package encrypt;

#-------------------------------------------------------------------------------
#                           DESÍT|[gpbP[W
#                           Ver1.0
# 
# pX[hÍsꍇ
# md5.plAdes.pl[hĂ
#
#-------------------------------------------------------------------------------

#---ϑ^Base64e[u
%b64_decode = (
'A', '000000',  'B', '000001',  'C', '000010',  'D', '000011',
'E', '000100',  'F', '000101',  'G', '000110',  'H', '000111',
'I', '001000',  'J', '001001',  'K', '001010',  'L', '001011',
'M', '001100',  'N', '001101',  'O', '001110',  'P', '001111',
'Q', '010000',  'R', '010001',  'S', '010010',  'T', '010011',
'U', '010100',  'V', '010101',  'W', '010110',  'X', '010111',
'Y', '011000',  'Z', '011001',  'a', '011010',  'b', '011011',
'c', '011100',  'd', '011101',  'e', '011110',  'f', '011111',
'g', '100000',  'h', '100001',  'i', '100010',  'j', '100011',
'k', '100100',  'l', '100101',  'm', '100110',  'n', '100111',
'o', '101000',  'p', '101001',  'q', '101010',  'r', '101011',
's', '101100',  't', '101101',  'u', '101110',  'v', '101111',
'w', '110000',  'x', '110001',  'y', '110010',  'z', '110011',
'0', '110100',  '1', '110101',  '2', '110110',  '3', '110111',
'4', '111000',  '5', '111001',  '6', '111010',  '7', '111011',
'8', '111100',  '9', '111101',  '-', '111110',  '_', '111111',
);
%b64_encode = (
'000000', 'A',  '000001', 'B',  '000010', 'C',  '000011', 'D',
'000100', 'E',  '000101', 'F',  '000110', 'G',  '000111', 'H',
'001000', 'I',  '001001', 'J',  '001010', 'K',  '001011', 'L',
'001100', 'M',  '001101', 'N',  '001110', 'O',  '001111', 'P',
'010000', 'Q',  '010001', 'R',  '010010', 'S',  '010011', 'T',
'010100', 'U',  '010101', 'V',  '010110', 'W',  '010111', 'X',
'011000', 'Y',  '011001', 'Z',  '011010', 'a',  '011011', 'b',
'011100', 'c',  '011101', 'd',  '011110', 'e',  '011111', 'f',
'100000', 'g',  '100001', 'h',  '100010', 'i',  '100011', 'j',
'100100', 'k',  '100101', 'l',  '100110', 'm',  '100111', 'n',
'101000', 'o',  '101001', 'p',  '101010', 'q',  '101011', 'r',
'101100', 's',  '101101', 't',  '101110', 'u',  '101111', 'v',
'110000', 'w',  '110001', 'x',  '110010', 'y',  '110011', 'z',
'110100', '0',  '110101', '1',  '110110', '2',  '110111', '3',
'111000', '4',  '111001', '5',  '111010', '6',  '111011', '7',
'111100', '8',  '111101', '9',  '111110', '-',  '111111', '_',
);
@zero = ( '', '00000', '0000', '000', '00', '0' );



return 1;

sub main::encrypt{
	
	($e_mode,$value,$opt) = @_;
	
	if    ($e_mode eq 'encrypt' ){ return(&des_crypt  ($value,$opt));}
	elsif ($e_mode eq 'backup'  ){ return(&des_backup ());           }
	elsif ($e_mode eq 'restore' ){ return(&des_restore($value));     }
	elsif ($e_mode eq 'set_seed'){ return(&des_setseed($value));     }
	elsif ($e_mode eq 'decrypt' ){ return(&des_decrypt($value,$opt));}
	elsif ($e_mode eq 'set_pass'){ return(&des_setpass($value));     }
	
}

sub des_backup{
	return(*crypt_key);
}
sub des_restore{
	(*rc_p) = @_;
	@crypt_key = @rc_p;
}

sub des_setseed{
	
	($value) = @_;
	
	@crypt_key =  &des::des_set_key(pack('H*',$value));
	
}

sub des_crypt{
	
	($value,$opt) = @_;
	
	$value   = &md5::convert($value).$value;
	$out_len = 8 - (length($value) % 8);
	$value   = $out_len.$value;
	
	$str = '';
	
	$cnt = int(length($value) / 8);
	$cnt -- if length($value) % 8 == 0;
	
	if ($opt eq 'b64'){
		foreach $a (0.. $cnt){
			$str .= &des::des_ecb_encrypt(*crypt_key,1,substr($value,$a*8,8));
		}
		$str  = unpack("B*", $str);
		$str .= $zero[(length($str))%6];
		$str  =~ s/(.{6})/$b64_encode{$1}/g;
		
	}else{
		foreach $a (0.. $cnt){
			$str .= unpack('H*',&des::des_ecb_encrypt(*crypt_key,1,substr($value,$a*8,8)));
		}
	}
	
	return(1,$str);
}

sub des_decrypt{
	
	($value,$opt) = @_;
	
	$str = '';
	if ($opt eq 'b64'){
		$value  =~ s/(.)/$b64_decode{$1}/g;
		$value  = pack('B*',$value);
		$cnt = int(length($value) / 8)-1;
		foreach $a (0.. $cnt){
			$str .= &des::des_ecb_encrypt(*crypt_key,0,substr($value,$a*8,8));
		}
	}else{
		$cnt = int(length($value) / 16)-1;
		foreach $a (0.. $cnt){
			$str .= &des::des_ecb_encrypt(*crypt_key,0,pack('H*',substr($value,$a*16,16)));
		}
	}
	
	
	#---f[^`FbN
	$out_len  = substr($str,0,1 );
	$md5_hash = substr($str,1,16);
	$out_data = substr($str,17,length($str)-16-$out_len);
	$md5_now  = &md5::convert($out_data);
	
	if ($md5_now ne $md5_hash){ return('ERROR:Ɏs܂');}
	
	return(1,$out_data);
	
}

sub des_setpass{
	
	($value) = @_;
	
	if (substr($value,0,1) eq "\\"){ $value = substr($value,1);     }
	else                           { $value = &md5::convert($value);
	                                 $value = unpack('H*',$value);  }
	
	&des_setseed($value);
	
	return(1,$value);
}

