#!/usr/bin/perl

binmode STDIN;
binmode STDOUT;

#-------------------------------------------------------------------------------
#
#                          Infinity Mail Engine Ver4.23
#                             -- MailControlSystem--
#
#                                for WebX Series
#
# Programmed By
# LunarNight
#
# &mailcontrol(<MODE>,<Pointer>,<ConfigPointer>);
#
#-------------------------------------------------------------------------------

#---̃Cȕ
$main::library_title  {"mailcontrol"} = "InfinityMailEngine";
$main::library_version{"mailcontrol"} = "4.24";
$main::library_maker  {"mailcontrol"} = "LunarNight";


#---OCuǂݏo
package mailcontrol;

$base_addr = "./lib/";

#---iv풓AVOinĥƂѐ
$SIG{'ALRM'}  = \&mailcontrol_timeout;
$timeout_time = "";

#---tϊpnbV
%day_hash = ( 'Sun' => '',
              'Mon' => '',
              'Tue' => '',
              'Wed' => '',
              'Thu' => '',
              'Fri' => '',
              'Sat' => 'y' );
              
%month_hash = ( 'Jan' => '01',
                'Feb' => '02',
                'Mar' => '03',
                'Apr' => '04',
                'May' => '05',
                'Jun' => '06',
                'Jul' => '07',
                'Aug' => '08',
                'Sep' => '09',
                'Oct' => '10',
                'Nov' => '11',
                'Dec' => '12' );

#---tpz
@youbi = ( 'Sun','Mon','Tue','Wed','Thu','Fri','Sat' );
@tsuki = ( 'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec' );

#---PoCg^QoCg^RoCgEUC-JPK\
$ascii      = '?:\x00-\x7F'             ;
$twoBytes   = '?:\x8E\xA1-\xFE\xA1-\xFE';
$threeBytes = '?:\x8F\xA1-\xFE\xA1-\xFE';

#-----gq̓o^
%kakutyousi = ();
open(IN,$base_addr.'mailcontrol_sub/dat/mime.dat');
while(<IN>){
	$_ =~ tr/ //d;
	my($key,$val) = split(/:/,$_);
	$kakutyousi{$key} = $val;
}

$socket_flag = 0;
$ssl_flag    = 0;
%login_ctl   = ();
$str_buf     = "";
$bufsize     = "1024";

$pop_ssl_flag  = 0;
$imap_ssl_flag = 0;
$smtp_ssl_flag = 0;
$sieve_ssl_flag= 0;
$main_ssl_flag = 0;

%sock_mode = ();
%sock_hash = ();

#---W[o^
%exec_hash= ();
%mld_hash = ();
open(IN,$base_addr.'mailcontrol_sub/dat/modules.dat');
while(<IN>){
	$_ =~ tr/ //d;
	my($key,$val) = split(/:/,$_);
	$mld_hash{$key} = $base_addr.$val;
}

return 1;
#-------------------------------------------------------------------------------------------------------
# C[eB
# &mailcontrol(<Pointer>,<ConfigPointer>);
#-------------------------------------------------------------------------------------------------------

sub main::mailcontrol{
	
	#---e擾
	$lib_mode  = $_[0];
	$lib_point = $_[1];
	$lib_config= $_[2];
	
	#---ݒǂݍ
	$timeout_h = $$lib_config{"timeout_handle"};
	$timeout_t = $$lib_config{"timeout"       };
	if ($timeout_t ne ""){ $timeout_time = $timeout_t;}
	if ($timeout_h ne ""){ $SIG{'ALRM'}  = $timeout_h;}
	
	#---萔擾
	$time_diff = $$lib_config{"time_diff"};
	
	#---
	if ($mld_hash{$lib_mode} ne ""){ ($rc,$type,$msg,$err_msg,$opt) = &execute($lib_mode,$lib_point,$lib_config);}
	else                           { ($rc,$type,$msg,$err_msg,$opt) = ('main','badcommand',$lib_mode);           }
	
	#---Error
	if ($rc ne "1"){ $err_msg = &execute('senderror',$type);
	                 return('mailcontrol->'.$rc."\0".$type."\0".$msg."\0".$err_msg);}
	
	return ($rc,$type,$msg,$err_msg,$opt);
	
}

#-------------------------------
#W[s
#-------------------------------
sub execute{
	
	($exec_mld,@opt_mld) = @_;
	
	if   ($mld_hash{$exec_mld} ne "" &&
	      $exec_hash{$exec_mld} != 1   ){ require $mld_hash{$exec_mld};
	                                      $exec_hash{$exec_mld} = 1;    }
	elsif($exec_hash{$exec_mld} == 1   ){                               }
	else                                { return('execute','nomodule',$exec_mld);}
	
	return(&$exec_mld(@opt_mld));
}

#-------------------------------
#tZo
#-------------------------------
sub mailcontrol_getday{
	
	$day_str = $_[0];
	
	($week,$day,$mon,$year,$time,$time_sa) = $day_str =~ /(\w+),* (\d+) (\w+) (\d+) ([\d:]+) ([\d\w+-]+)/;
	($day,$mon,$year,$time,$time_sa) = $day_str =~ /(\d+) (\w+) (\d+) ([\d:]+) ([\d\w+-]+)/ unless $week;
	
	if (length($day) == 1 ){ $day = "0$day";        }
	if (length($year) == 2){ $year= "19".$year;     }
	
	$day_dat = "$year/$month_hash{$mon}/$day $day_hash{$week} $time $time_sa";
	$day_dat = "" if $day_str eq "";
	
	return $day_dat;
}

sub mailcontrol_getdate{

	#---擾
	if (! (($type,$hour,$min,$sec) = $time_diff =~ /([\+|\-])(\d{2}):(\d{2}):(\d{2})/)){ $hour = 9; $min = 0; $sec = 0; $type = "+";}
	
	#---GMT擾
	$now_time = time();
	if ($type eq "-"){ $now_time -= 3600*$hour+$min*60+$sec;}
	else             { $now_time += 3600*$hour+$min*60+$sec;}
	@tgmt = gmtime($now_time);

	$send_date = sprintf( "%s, %2d %s %d %02d:%02d:%02d %s%02d%02d",
			$youbi[$tgmt[6]],
			$tgmt[3],
			$tsuki[$tgmt[4]],
			1900 + $tgmt[5],
			$tgmt[2],
			$tgmt[1],
			$tgmt[0],
			$type,
			$hour,
			$min);
	
	return($send_date);
	
}

sub mailcontrol_getyear{

	#---擾
	if (! (($type,$hour,$min,$sec) = $time_diff =~ /([\+|\-])(\d{2}):(\d{2}):(\d{2})/)){ $hour = 9; $min = 0; $sec = 0; $type = "+";}
	
	#---GMT擾
	$now_time = time();
	if ($type eq "-"){ $now_time -= 3600*$hour+$min*60+$sec;}
	else             { $now_time += 3600*$hour+$min*60+$sec;}
	@tgmt = gmtime($now_time);

	return(1900 + $tgmt[5]);
	
}

sub mailcontrol_getmsgid{
	
	($mail_addr) = @_;
	
	$mail_addr = 'hoge@hoge.hoge.jp' if $mail_addr eq '';
	if (! (($type,$hour,$min,$sec) = $time_diff =~ /([\+|\-])(\d{2}):(\d{2}):(\d{2})/)){ $hour = 9; $min = 0; $sec = 0; $type = "+";}
	
	#---GMT擾
	$now_time = time();
	if ($type eq "-"){ $now_time -= 3600*$hour+$min*60+$sec;}
	else             { $now_time += 3600*$hour+$min*60+$sec;}
	@tgmt = gmtime($now_time);

	$send_msgid = sprintf( '%04d%02d%02d%02d%02d%02d.%06d.%s',
			1900 + $tgmt[5],
			$tgmt[4]+1,
			$tgmt[3],
			$tgmt[2],
			$tgmt[1],
			$tgmt[0],
			rand(1000000),
			$mail_addr);
	
	return($send_msgid);
}

#-------------------------------------------------------------------------
# f[^ʐM
#-------------------------------------------------------------------------

sub data_tr{
	($dat,$handle,$ssl_flag) = @_;
	if ($ssl_flag == 1){
		if ($sock_mode{$handle} == 1){
			Net::SSLeay::write($sock_hash{$handle},$dat);
		}else{
			$sock_hash{$handle}->print($dat);
		}
	}else{
		print $handle $dat;
	}
	return(1);
}

sub data_rc{
	($handle,$ssl_flag) = @_;
	
	if ($ssl_flag == 1){
		if ($sock_mode{$handle} == 1){
			$idx = $mode = "";
			while(($idx = index($str_buf, "\n")) < 0) {
				if (!($more = Net::SSLeay::read($sock_hash{$handle},$bufsize))) {
					# MI
					$rcd = $str_buf;
					$str_buf = "";
					return $rcd;
				}
				$str_buf .= $more;
			}
			$rcd = substr($str_buf, 0, $idx+1);
			$str_buf = substr($str_buf, $idx+1);
		}else{
			$idx = $mode = "";
			while(($idx = index($str_buf, "\n")) < 0) {
				if (!($sock_hash{$handle}->read($more,$bufsize))) {
					# MI
					$rcd = $str_buf;
					$str_buf = "";
					return $rcd;
				}
				$str_buf .= $more;
			}
			$rcd = substr($str_buf, 0, $idx+1);
			$str_buf = substr($str_buf, $idx+1);
		}
	}else{
		$rcd = <$handle>;
	}
	return($rcd);
}

sub imap4_com{
	($command) = @_;
	
	$out = "";
	$com = "";
	&imap4_tr("0000 $command\r\n");
	while(1){
		$tmp = &imap4_rc();
		if (substr($tmp,0,4) eq "0000"){
			$com  = substr($tmp,5);
			last;
		}else{
			$out .= substr($tmp,2);
		}
	}
	return($com,$out);
}

sub smtp_rc{
	
	$rc ="";
	$rc2="";
	
	while(1){
		$rc   = &data_rc("SMTP",$smtp_ssl_flag);
		$rc   =~ tr/\r//;
		$rc2 .= $rc;
		if ($rc !~ /^\d{3}\-/){ last;}
	}
	return($rc2);
}

sub sieve_rc{
	$rc2 = "";
	$rc = &data_rc("SIEVE",$sieve_ssl_flag);
	($size) = $rc =~ /\{(\d+)\}/;
	
	if ($size eq ""){
		$rc2 = $rc;
		while(1){
			$stat = substr($rc,0,2);
			if ($stat eq "OK" ||
			    $stat eq "NO"  ){ last;}
			
			$rc   = &data_rc("SIEVE",$sieve_ssl_flag);
			$rc   =~ tr/\r//;
			$rc2 .= $rc;
		}
	}else{
		$size++;
		while(1){
			$rc = &data_rc("SIEVE",$sieve_ssl_flag);
			$rc =~ tr/\r//;
			
			$rc2 .= $rc;
			if ($size <= length($rc2)){ last;}
		}
		$stat = "OK";
	}
	
	return($stat,$rc2);
}

sub imap4_rc{
	return(&data_rc("IMAP4",$imap_ssl_flag));
}

sub pop3_rc{
	return(&data_rc("POP3",$pop_ssl_flag));
}
sub http_rc{
	return(&data_rc("HTTP",$http_ssl_flag));
}

sub pop3_tr{
	($dat) = @_;
	return(&data_tr($dat,"POP3",$pop_ssl_flag));
}

sub sieve_tr{
	($dat) = @_;
	return(&data_tr($dat,"SIEVE",$sieve_ssl_flag));
}

sub smtp_tr{
	($dat) = @_;
	return(&data_tr($dat,"SMTP",$smtp_ssl_flag));
}
sub imap4_tr{
	($dat) = @_;
	return(&data_tr($dat,"IMAP4",$imap_ssl_flag));
}
sub http_tr{
	($dat) = @_;
	return(&data_tr($dat,"HTTP",$http_ssl_flag));
}


#-------------------------------------------------------------------------
# HMAC MD5vZ
#-------------------------------------------------------------------------
sub hmac_md5{
    ($data, $key) = @_;
    
    $block_size   = 64;
    $block_size ||= 64;
    $key = &md5::convert($key) if length($key) > $block_size;

    $k_ipad = $key ^ (chr(0x36) x $block_size);
    $k_opad = $key ^ (chr(0x5c) x $block_size);

    &md5::convert($k_opad.&md5::convert($k_ipad.$data));
}

#-------------------------------------------------------------------------
# SSL
#-------------------------------------------------------------------------
sub init_ssl{

	if ($ssl_flag == 0){
		eval "use Net::SSLeay";
		$@ && return(&init_crypt_ssl());
		eval "Net::SSLeay::SSLeay_add_ssl_algorithms()";
		eval "Net::SSLeay::load_error_strings()";
		$main_ssl_flag = 1;
	}
	return(1);
}

sub init_crypt_ssl{

	if ($ssl_flag == 0){
		eval "use Net::SSL";
		$@ && return('init_ssl','use_ssl','Net::SSLeay+Crypt::SSL');
		$main_ssl_flag = 2;
	}
	return(1);
}

#-------------------------------------------------------------------------
# DataAnalyzeSub
#-------------------------------------------------------------------------

sub searchval{
	($target,$start,$end,$position) = @_;
	
	$tmp1 = index($target,$start,$position);
	$tmp2 = index($target,$end,$tmp1);
	
	return(substr($target,$tmp1,$tmp2-$tmp1),$tmp2,$tmp1);
}

sub splitval{
	($target,$start,$end) = @_;
	
	$tmp1 = index($target,$end);
	$tmp2 = rindex($target,$start,$tmp1);
	
	return(substr($target,$tmp2,$tmp1-$tmp2+length($end)));
}
sub splittag{
	($target,$start,$end) = @_;
	
	$tmp1 = index($target,$start);
	$tmp2 = index($target,$end,$tmp1);
	
	return(substr($target,$tmp1,$tmp2-$tmp1));
}

sub getvalue{
	($target,$point) = @_;
	
	($out) = $target =~ /$point="*([^"> ]+)\"*/i;
	
	return($out);
}

