#-------------------------------------------------------------------------------------------------------
# [{bNXXe[^X
# &imap4boxstat(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           mojicode -- sjis/euc   imap_server   --- IMAP Server
#           mail_box -- MailBox    imap_port     --- IMAP Port
#                                  imap_account  --- IMAP Account
#                                  imap_password --- IMAP Password
#                                  imap_ssl      --- IMAP over SSL (ssl|"")
#
# Output: 1,<MaxMsg>,<UnSeen>,<ReCent>
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub imap4boxstat{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	$mojicode = $lib_pointer{"mojicode"};
	$getname  = $lib_pointer{"getname" };
	$delimit  = $lib_pointer{"delimit" };
	$mail_box = $lib_pointer{"mail_box"};
	
	#---ڑmF
	if($login_ctl{"imap"} != 1 ){ return('imap4boxstat','notlogin','IMAP4'); }
	
	#---[{bNXI
	$unseen = 0;
	($rc,$recent,$message) = &execute('imap4select',$mail_box);
	if ($rc ne "1"){ return('imap4boxstat','select',$recent."\n".$message);}
	
	#---Unseen擾
	if ($message != 0){
		($com,$rc) = &imap4_com('SEARCH UNSEEN');
		if (substr($com,0,2) ne "OK"){ return('imap4boxstat','search',$rc."\n".$com);}
		$unseen = $rc =~ tr/ //;
	}
	
	if ($getname ne ""){
		#---؂F
		if ($delimit eq ""){
			($rc,$flag,$delimit,$name) = &execute('imap4getdelimit',$mail_box);
			if ($rc ne "1"){ ($rc,$flag,$delimit,$name) = ('','','','');}
		}
		
		$mail_box =~ s/\\\\/\\/g;
		$mail_box =~ s/\Q$delimit\E/\0/g if $delimit ne "";
		&main'imap_utf_d(*mail_box,$mojicode);
		
		($rc,$msg,$errmsg) = &execute('imap4specialbox','replace',\$mail_box);
		if ($rc ne "1"){ return('imap4gettree->'.$rc,$msg,$errmsg);}

		$mail_box =~ s/\0/\//g if $delimit ne "";
		
	}
	
	
	return(1,$message,$unseen,$recent,$mail_box,$delimit);
}


