#-------------------------------------------------------------------------------------------------------
# [ꗗ
# &imap4maillist(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer       <ConfigPointer>HashPointer
#           mojicode -- OutputJPCode   
#           start    -- StarNo         
#           maxlist  -- MaxReadCnt     
#           script   -- ScriptRoutin   
#           reverse  -- ReverseRead    
#           mailbox  -- TargetMailBox
#
# DefaultOutput:HashPointer
#         -> [No:<MailNo> :<Action>
#            total_cnt   -> [
#            <MailNo>-<Action>
#            Action => from     -- MailFrom
#                   => subject  -- MailSubject
#                   => date     -- MailDate
#                   => id       -- MailID
#                   => mult     -- MultiPartMail "1" łȂ""
#                   => seen     -- [1=Seen|]
#
# Script[eBpOutput:
#            total_cnt  -> [
#            now_cnt    -> ǂݏoJn[No
#
# ftHgl
# minlist     eq ""  -> 1
# maxlist     eq ""  -> 
# 
# script[eB̕ϐ
# 
#  -- NowCnt,MaxCnt,MailNo,From,Subject,Date,multflag[1|""],ID,Seen[1|""]
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub imap4maillist{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	#---eϐ^ݒ擾
	$start_list = $lib_pointer{"startlist"};
	$max_list   = $lib_pointer{"maxlist"  };
	$script_sub = $lib_pointer{"script"   };
	$rev_flag   = $lib_pointer{"reverse"  };
	$mojicode   = $lib_pointer{"mojicode" };
	$mailbox    = $lib_pointer{"mailbox"  };
	
	#---ڑmF
	if($login_ctl{"imap"} != 1 ){ return('imap4maillist','notlogin','IMAP4'); }
	
	#---ϐ
	%output_maillist = ();
	if ($mojicode eq ""){ $mojicode = "euc";        }
	else                { $mojicode = $mojicode;    }
	
	#---[{bNXI
	($rc,$rec,$max_cnt) = &execute('imap4select',$mailbox);
	if ($rc ne "1"){ return('imap4maillist','select',$rec."\n".$max_cnt);}
	
	#---ftHglZbg
	if ($rev_flag eq "" || $rev_flag eq "0"){
		$counter = 1;
		if ($start_list == 0){ $start_list = 1;       }
		if ($max_list   == 0){ $max_list   = $max_cnt;}
		$target_list = $start_list + $max_list;
		$mail_no     = $start_list;
		if ($target_list > $max_cnt){ $target_list = $max_cnt;}
		$target_list++;
	}else{
		$counter = -1;
		if ($start_list == 0){ $start_list = 1;       }
		if ($max_list   == 0){ $max_list   = $max_cnt;}
		$start_list = $max_cnt-($start_list-1);
		
		$target_list = $start_list - $max_list+1;
		$mail_no     = $start_list;
		if ($target_list < 1){ $target_list = 1;}
		$target_list--;
	}
	
	if ($max_cnt == 0){ %output_maillist = ("total_cnt"  => 0,
		                                      "now_cnt"    => 0 );
		                  return (1,*output_maillist);
		                                                           }
	
	#---ǃ`FbN
	%unseen_hash = ();
	if ($start_list < $target_list){
		$fstart = $start_list;
		$fend   = $target_list-1;
	}else{
		$fstart = $target_list+1;
		$fend   = $start_list;
	}
	($rc,$com) = &imap4_com("SEARCH $fstart:$fend UNSEEN");
	if (substr($rc,0,2) ne "OK"){ return('imap4maillist','search unseen',$rc."\n".$com);}
	foreach $a ($com =~ /(\d+)/g){
		$unseen_hash{$a} = "1";
	}
	
	
	#---[MJn
	while (($mail_no != $target_list) && $mail_no > 0 && $mail_no < $max_cnt+1){
		
		if ($timeout_time ne ""){ alarm($timeout_time);
		                          $timeout_msg = "TimeOutError: FETCH BODY.PEEK Command";}
		&imap4_tr("0000 FETCH $mail_no BODY.PEEK[header.fields (subject from to cc message-id content-type date)]\r\n");
		
		#---tO
		$header_flag = "";
		$part_flag   = "";
		
		
		#---ϐ
		$mail_mult = "";
		$mail_subj = "";
		$mail_from = "";
		$mail_date = "";
		$mail_id   = "";
		$mail_to   = "";
		$mail_cc   = "";
		$mail_seen = "";
		
		#---alarm~߂
		if ($timeout_time ne ""){ alarm(0);}
		
		while(1){
			$rc = &imap4_rc();
			if (substr($rc,0,4) eq "0000"){ last;}
			
			$rc =~ s/\x0D?\x0A?$//;
			
			if ($rc eq ""       ){ $part_flag = "1";}
			if ($part_flag ne ""){ next;            }
			
			#---wb_[ MIME Decode R[h$mojicode
			&mojicode'mime_dec(*rc,$mojicode);
#			$rc = &main::mimedecode($rc, $mojicode);
			
			#---wb_[^CvF^ϐ
			if    ($rc =~ /^from:/oi      ){ $header_flag = "mail_from"; $rc = substr($rc,6);  &jcode'convert(*rc,lc($mojicode)); }
			if    ($rc =~ /^to:/oi        ){ $header_flag = "mail_to"  ; $rc = substr($rc,4);  &jcode'convert(*rc,lc($mojicode)); }
			if    ($rc =~ /^cc:/oi        ){ $header_flag = "mail_cc"  ; $rc = substr($rc,4);  &jcode'convert(*rc,lc($mojicode)); }
			elsif ($rc =~ /^subject:/oi   ){ $header_flag = "mail_subj"; $rc = substr($rc,8);  &jcode'convert(*rc,lc($mojicode)); 
			                                                             if (substr($rc,0,1) eq " "){ substr($rc,0,1) = "";}      }
			elsif ($rc =~ /^message-id:/oi){ $header_flag = "mail_id"  ; $rc = substr($rc,12);    }
			elsif ($rc =~ /^date:/oi      ){ $header_flag = "mail_date";
			                                  $rc = substr($rc,5);
			                                  $rc = &mailcontrol_getday($rc);
			                                  &jcode'convert(*rc,lc($mojicode));
			                                                                                       }
			elsif ($rc =~ /^([\w\-]+):/         &&
			       lc(substr($rc,0,3)) ne "re:" &&
			       lc(substr($rc,0,3)) ne "fw:" ){ $header_flag = "";                              }
			else                                 { $rc =~ s/^	+|^ +//g;                            }
			
			#---MultiPartF
			if    ($rc =~ /boundary=/oi ){ $mail_mult = "1";}
			
			#---wb_[񏑂
			if ($header_flag ne ""){ $$header_flag .= $rc; }
			
		}
		
		#---tOF
#		if ($timeout_time ne ""){ alarm($timeout_time);
#		                          $timeout_msg = "TimeOutError: FETCH FLAGS Command";}
#		($rc,$com) = &imap4_com("FETCH $mail_no FLAGS");
#		if ($com =~ /\\Seen/i){ $mail_seen = "1";}
#		else                  { $mail_seen = ""; }
		
		$mail_seen = "1";
		$mail_seen = ""  if $unseen_hash{$mail_no} eq "1";
		
		if ($script_sub ne ""){ $now_cnt = $max_cnt - $mail_no + 1;
		                        &$script_sub($now_cnt,$max_cnt,$mail_no,$mail_from,$mail_to,$mail_cc,$mail_subj,$mail_date,$mail_mult,$mail_id,$mail_seen);}
		else                  {
			
			$output_maillist{"$mail_no-from"   } = $mail_from;
			$output_maillist{"$mail_no-to"     } = $mail_to  ;
			$output_maillist{"$mail_no-cc"     } = $mail_cc  ;
			$output_maillist{"$mail_no-subject"} = $mail_subj;
			$output_maillist{"$mail_no-date"   } = $mail_date;
			$output_maillist{"$mail_no-mult"   } = $mail_mult;
			$output_maillist{"$mail_no-seen"   } = $mail_seen;
			$output_maillist{"$mail_no-id"     } = $mail_id  ;
			
		}
		
		$mail_no += $counter;
	}
	
	$output_maillist{"total_cnt" } = $max_cnt   ;
	$output_maillist{"now_cnt"   } = $start_list;
	
	return(1,*output_maillist);
	
}

