#-------------------------------------------------------------------------------------------------------
#                          mailcontrol.plW[  - SASLF؏
#
# Programmed by LunarNight
#-------------------------------------------------------------------------------------------------------

return 1;

sub sasl{
	
	($mode,$user,$pass,$challenge) = @_;
	
	if   ($mode eq "plain"   ){ return(&sasl_plain   ($user,$pass)           );}
	elsif($mode eq "cram-md5"){ return(&sasl_cram_md5($user,$pass,$challenge));}
	
}

sub sasl_cram_md5{
	($user,$pass,$challenge) = @_;
	
	$challenge  = &main::bodydecode($challenge,"b64");
	$challenge .= &main::bdeflush();
	
	$keyed_md5  = &hmac_md5($challenge,$pass);
	$keyed_md5  = unpack("H*",$keyed_md5);

	$res_key    = &main::bodyencode($user." ".$keyed_md5,"b64");
	$res_key   .= &main::benflush();
	$res_key    =~ tr/\r\n//d;
	
	return(1,$res_key);
}

sub sasl_plain{
	
	($user,$pass) = @_;
	
	$res_key  = &main::bodyencode($user."\0".$user."\0".$pass);
	$res_key .= &main::benflush();
	$res_key  =~ tr/\n\r//d;
	
	return(1,$res_key);
}
