
#-------------------------------------------------------------------------------------------------------
# SieveXNvg擾
# &sieveget(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           mojicode -- JP Code    
#           scr_name -- ScriptName 
#                                  
# for EditMode
#
# DataHash Format
#  mode  -- "EDIT"
#  max   -- MAX_ID
#  <ID>-max  -- ID MaxItem
#  <ID>-name -- MailBox
#  <ID>-<ItemID>-type  -- in  || not
#  <ID>-<ItemID>-mode  -- and || or
#  <ID>-<ItemID>-match -- 1   || ""
#  <ID>-<ItemID>-head  -- <Header>
#  <ID>-<ItemID>-data  -- <Data>
#
# for DirectMode
# 
# DataHash Format
#  mode  -- "DIRECT"
#  data  -- <ScriptData>
#
# Output: <RC_Code>,<DataHasP>
#
#-------------------------------------------------------------------------------------------------------
return 1;

sub sieveget{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	$mojicode= $lib_pointer{"mojicode"};
	$scr_name= $lib_pointer{"scr_name"};
	if ($mojicode ne "euc"  &&
	    $mojicode ne "sjis" &&
	    $mojicode ne "jis"  ){ $mojicode = "euc";}
	&jcode'convert(*scr_name,$mojicode);
	
	#---G[`FbN
	if ($login_ctl{"sieve"} != 1 ){ return('sieveget','notlogin','SIEVE'); }
	if ($scr_name eq ""          ){ return('sieveget','noscrname');        }
	
	#---XNvg擾
	
	&sieve_tr("getscript \"$scr_name\"\r\n");
	($rc,$out) = &sieve_rc();
	if ($rc ne "OK"){ return('sieveget','getscript',$rc."\n".$out);}
	
	#---R[hϊ
#	&jcode'convert(*out,$mojicode);
	
	#---XNvg
	$out =~ tr/\r//d;
	$analyze  = 0;
	$now_id   = 0;
	%scr_data = ();
	foreach $a (split(/\n/,$out)){
		
		#---XNvgmF
		if ($a eq "# WebX Series Sieve Script Generator"){ $analyze = 1; next;}
		if ($analyze != 0){ $a = substr($a,2); &jcode'convert(*a,$mojicode);}
		
		
		if ($a eq "START" && $analyze == 1){ $analyze = 2; next;}
		if ($a eq "END"   && $analyze != 0){               last;}
		if ($a eq "---"   && $analyze != 0){ $analyze++;   next;}
		
		if ($analyze == 2){ $scr_data{"default"} = $a; next;}
		if ($analyze == 3 ||
		    $analyze == 6){ 
			if ($analyze == 6){
				$scr_data{$now_id."-max"} = $item_id;
				$now_id++;
			}
			$item_id=0; $analyze=4;
		}
		if ($analyze == 4){
			$scr_data{$now_id."-name"} = $a;
			$scr_data{$a} = $now_id;
			$analyze=5;
			next;
		}
		if ($analyze == 5){
			($type,$mode,$match,$head,$data) = split(/\0/,$a);
			if ($data ne ""){
				$scr_data{$now_id."-".$item_id."-type" } = $type ;
				$scr_data{$now_id."-".$item_id."-mode" } = $mode ;
				$scr_data{$now_id."-".$item_id."-match"} = $match;
				$scr_data{$now_id."-".$item_id."-head" } = $head ;
				$scr_data{$now_id."-".$item_id."-data" } = $data ;
				$item_id++;
				next;
			}
		}
	}
	&mojicode'convert(*out,$mojicode,'utf-8');
	$scr_data{"max" } = $now_id;
	$scr_data{"data"} = $out;
	
	#---[h
	if ($analyze != 0){ $scr_data{"mode"} = "EDIT";  }
	else              { $scr_data{"mode"} = "DIRECT";}
	
	
	return(1,*scr_data);
	
}
