
#-------------------------------------------------------------------------------------------------------
# SieveXNvgꗗ擾
# &sievelist(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           mojicode -- JP Code    
#                                  
# Output: HashPointer | ErrMsg
#         => <RresCode>,<ScriptListArrayP>,<ScriptStatHashP>
#         
#-------------------------------------------------------------------------------------------------------
return 1;

sub sievelist{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	#---e擾
	$mojicode = $lib_pointer{"mojicode"};
	if ($mojicode ne "euc"  &&
	    $mojicode ne "sjis" &&
	    $mojicode ne "jis"  ){ $mojicode = "euc";}
	
	#---G[`FbN
	if ($login_ctl{"sieve"} != 1 ){ return('sievelist','notlogin','SIEVE'); }
	
	&sieve_tr("listscripts\r\n");
	($rc,$out) = &sieve_rc();
	if ($rc ne "OK"){ return('sievelist','listscript',$rc."\n".$out);}
	
	%scr_list = ();
	@scr_array= ();
	foreach $a (split(/\n/,$out)){
		($data,$opt) = $a =~ /^\"([^\"]+)\"\s*(\w*)/;
		if ($data eq "" ||
		    $data eq "OK" ){ next;}
		
		&jcode'convert(*data,$mojicode);
		
		push(@scr_array,$data);
		$scr_list{$data} = $opt;
	}
	
	return(1,*scr_array,*scr_list);
}
	