#-------------------------------------------------------------------------------------------------------
# W[M
# &sendmail(<Pointer>,<ConfigPointer>);
# 
# Input: <Pointer> HashPointer                               <ConfigPointer> HashPointer
#         => from        -- From                               => smtp_server -- SMTP Server
#            to          -- To (J}؂蕡w)           smtp_port   -- SMTP Port
#            cc          -- CC                                    pop_server   -- <POP3 Server>
#            bcc         -- Bcc                                   pop_port     -- <POP3 Port>
#            subject     -- Subject                               pop_account  -- <POP3 Account>
#            date        -- Date                                  pop_password -- <POP3 Password>
#            in-reply-to -- In-Reply-To                           pop_type     -- <apop|pop3|""=auto>
#            references  -- References                            
#            reply-to    -- Reply-To
#            other_head  -- AddHeader                  
#            message     -- Message                    
#            mailbox     -- MailBox      (IMAP4p)
#            rcpt        -- MAhX
#            sender      -- MAIL Fromp[AhX
#            selfaddr    -- [ȃ[AhX]
#
#            sendfile    -- <HashPointer>
#                           filename1[:content_type] => DATA1,
#                           filename2[:content_type] => DATA2,
#                           ,
#                           ,
#            
#            foward      -- tH[h[
#
# ȃ[AhXɃ[AhXw肷ƁA
#   ̃AhXɂAMeM
#
# Output: ArrayPointer
# => <Status[OK or Error]>:<SendAddress>:<RcMessage>
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub sendmail{
	
	#---e|C^擾
	(*lib_pointer,*lib_config) = @_;
	
	#---eϐ擾
	$mail_from   = $lib_pointer{"from"       };
	$mail_to     = $lib_pointer{"to"         };
	$mail_cc     = $lib_pointer{"cc"         };
	$mail_bcc    = $lib_pointer{"bcc"        };
	$mail_subj   = $lib_pointer{"subject"    };
	$mail_date   = $lib_pointer{"date"       };
	$mail_reply  = $lib_pointer{"reply-to"   };
	$mail_repl   = $lib_pointer{"in-reply-to"};
	$mail_ref    = $lib_pointer{"references" };
#	$mail_head   = $lib_pointer{"other_head" };
	$mail_body   = $lib_pointer{"message"    };
	$mail_id     = $lib_pointer{"message-id" };
	*mail_file   = $lib_pointer{"sendfile"   };
	$mail_fow    = $lib_pointer{"foward"     };
	$mail_sender = $lib_pointer{"sender"     };
	$mail_self   = $lib_pointer{"selfaddr"   };
	$mail_rcpt   = $lib_pointer{"rcpt"       };
	$mail_box    = $lib_pointer{"mailbox"    };
	$con_type    = $lib_pointer{"mode"       };
	$mailsign_str= $lib_pointer{"mailsign"   };
	
	#---ϐ
	@output_sendstate = ();
	@file_list        = keys(%mail_file);
	
	#---Content-TypeF
	if ($mail_fow ne "" || $#file_list != -1 ){ #-----boundary̍쐬
		                                          $boundary_data = localtime;
		                                          $boundary_data =~ tr/ :/__/d;
		                                          $boundary_data = "--NEXT_PART_$boundary_data==";
		
		                                          $content_type = "Multipart/Mixed\; boundary=\"$boundary_data\"";}
	else                                      { $content_type = "text/plain\; charset=iso-2022-jp";             }
	
	
	#---SMTPZbVJn
	
	($rc,$type,$msg) = &execute("smtp","",*lib_config);
	if ($rc ne "1"){ return('sendmail->'.$rc,$type,$msg);}
	
	
	#---alarm~߂
	if ($timeout_time ne ""){ alarm(0);}
	
	#---MM
	($mail_addr) = $mail_from =~ /([0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+)/;
	if ($mail_addr eq ""  ){ $mail_addr = "localhost\@localdomain";}
	if ($mail_sender ne ""){ $mail_addr = $mail_sender;            }
	
	&smtp_tr("MAIL FROM:<$mail_addr>\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) ne "250"){ &execute("closesmtp");
	                               return('sendmail','mailfrom',$rc);}
	
	#---M摗M
	$flag = 0;
	if ($mail_rcpt ne ""){ $mail_to2 = $mail_rcpt;}
	else                 { $mail_to2 = $mail_to  ;}
	foreach $lib_a (split(/,/,$mail_to2.",".$mail_cc.",".$mail_bcc)){
		
		if ($lib_a !~ /[0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+/o){ next;}
		
		($send) = $lib_a =~ /([0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+)/;
		
		&smtp_tr("RCPT To:<$send>\r\n");
		$rc = &smtp_rc();
		if (substr($rc,0,3) ne "250"){ push(@output_sendstate,"Error\0$send\0$rc");         }
		else                         { push(@output_sendstate,"OK\0$lib_a\0$rc"  ); $flag++;}
		
	}
	if ($mail_self ne ""){ &smtp_tr("RCPT To:<$mail_self>\r\n");
		                     $rc = &smtp_rc();
		                     if (substr($rc,0,3) ne "250"){ push(@output_sendstate,"Error\0$mail_self\0$rc");        }
		                     else                         { push(@output_sendstate,"OK\0$mail_self\0$rc"   );$flag++;}
	}
	
	#---To/Cc/Bcc`
	$mail_cc    =~ s/,+$//;
	$mail_cc    =~ s/,/,\r\n    /g;
	$mail_bcc   =~ s/,+$//;
	$mail_bcc   =~ s/,/,\r\n    /g;
	$mail_to    =~ s/,+$//;
	$mail_to    =~ s/,/,\r\n    /g;
	$mail_reply =~ s/,+$//;
	$mail_reply =~ s/,/,\r\n    /g;
	
	#---f[^MJn
	&smtp_tr("DATA\r\n");
	$rc = &smtp_rc();
	if (substr($rc,0,3) eq "503" && $flag == 0){ &execute("closesmtp");
	                                             return (1,*output_sendstate);
	                                                                              }
	if (substr($rc,0,3) ne "354"){ return('sendmail','data',$rc);}
	
	
	#-----------------------------{M-------------------------------#
	
	#---wb_[쐬
	$header  = "From: $mail_from\n";
	$header .= "To: $mail_to\n";
	$header .= "Subject: $mail_subj\n";
	$header .= "Mime-Version: 1.0\n";
	$header .= "Content-type: $content_type\n";
	$header .= "Content-Transfer-Encoding: 7bit\n";
	
	#---ǉwb_[
	if ($mail_date  eq ""){ $send_date = &mailcontrol_getdate();
	                        $header .= "Date: $send_date\n";
	                                                                                           }
	else                  { $header .= "Date: $mail_date\n";                                   }
	if ($mail_cc    ne ""){ $header .= "Cc: $mail_cc\n";                                       }
	if ($mail_reply ne ""){ $header .= "Reply-To: $mail_reply\n";                              }
#	if ($mail_bcc   ne ""){ $header .= "Bcc: $mail_bcc\n";                                     }
	if ($mail_repl  ne ""){ $header .= "In-Reply-To: $mail_repl\n";                            }
	if ($mail_ref   ne ""){ $header .= "References: $mail_ref\n";                              }
	if ($mail_id    ne ""){ $header .= "Message-Id: <".&mailcontrol_getmsgid($mail_addr).">\n";}
	
#	$header .= "$mail_head";
	
#	$header =~ s/\r\n\r\n/\r\n/g;
#	$header =~ s/(\r\n)$//;
	
	&main::jcode'convert(*header,"jis");
	$header = &main::mimeencode($header);
	$header =~ s/\n/\r\n/g;
	&smtp_tr($header."\r\n");
	
	#---}`p[g
	if ($boundary_data ne ""){ $header2  = "--$boundary_data\r\n";
	                           $header2 .= "Content-Type: text/plain; ";
	                           $header2 .= "charset=\"iso-2022-jp\"\r\n";
	                           $header2 .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
	                           &smtp_tr($header2);
	                                                                                 }
	
	#---Body
	$mail_body    =~ tr/\r//d;
	$mailsign_str =~ tr/\r//d;
	&main::jcode'convert(*mail_body,"jis");
	&main::jcode'convert(*mailsign_str,"jis");
	foreach $lib_c (split(/\n/,$mail_body."\n".$mailsign_str)){
		$lib_c .= "\r\n";
		if ($lib_c =~ /^\.+\r\n/){ &smtp_tr(".".$lib_c);}
		else                     { &smtp_tr($lib_c);    }
	}
	&smtp_tr("\r\n");
	
	#-------------------------tH[hM----------------------------#
	
	if ($mail_fow ne ""){
		
		$header2  = "--$boundary_data\r\n";
		$header2 .= "Content-Type: message/rfc822\r\n";
		$header2 .= "Content-Description: FwMail\r\n\r\n";
		&smtp_tr($header2);
		
		if ($con_type eq "imap" && $mail_box ne ""){
			
			#---IMAP4T[o[ڑ
			($rc,$type,$msg) = &execute("imap4login","",*lib_config);
			if ($rc ne "1"){ &execute("imap4logout");
			                &execute("closesmtp",1);
			                return('sendmail->'.$rc,$type,$msg);}
			
			#---[{bNXI
			if ($timeout_time ne ""){ alarm($timeout_time);
			                          $timeout_msg = "TimeOutError: SELECT Command";}
			($rc,$com) = &imap4_com("SELECT \"$mail_box\"");

			if (substr($rc,0,2) ne "OK"){ &execute("imap4logout");
			                              &execute("closesmtp",1);
			                              return('sendmail','select',$rc."\n".$com);}
			
			&imap4_tr("0000 FETCH ".$mail_fow." RFC822\r\n");
			$msg = &imap4_rc();
			if (substr($msg,0,4) eq "0000"){ &execute("imap4logout");
			                                 &execute("closesmtp",1);
			                                 return('sendmail','fetch',$rc."\n".$com);}
			($total_size) = $msg =~ /\{(\d+)\}/;
			$nowsize=0;
			
			while(1){
				$buf = &imap4_rc();
				if (substr($buf,0,4) eq "0000"){ last;}
				if ($nowsize >= $total_size   ){ next;}
				$nowsize += length($buf);
				
				$buf  =~ tr/\r\n//d;
				$buf .= "\r\n";
				if ($buf =~ /^\.+\n/){ &smtp_tr(".".$buf);}
				else                 { &smtp_tr($buf);    }
			}
			
			&execute("imap4logout");
			
		}elsif($con_type ne "imap"){
			
			#---POP3T[o[ڑ
			($rc,$type,$msg) = &execute("pop3login","",*lib_config);
			if ($rc ne "1"){ &execute("pop3logout");
			                &execute("closesmtp");
			                return('sendmail->'.$rc,$type,$msg);}
			
			#---[M
			if ($timeout_time ne ""){ alarm($timeout_time);
			                          $timeout_msg = "TimeOutError: RETR Command";}
			&pop3_tr("RETR $mail_fow\r\n");
			$rc = &pop3_rc();
			if( $rc !~ /\+OK/ ) { &execute("pop3logout");
			                      &execute("closesmtp");
			                      return('sendmail','retr',$rc);}
			
			if ($timeout_time ne ""){ alarm(0);}
			
			while(1){
				$buf = &pop3_rc();
				if( $buf =~ /^\.\r\n/ ) { last; }
				&smtp_tr($buf);
			}
			
			&execute("pop3logout");
		}
	}
	
	
	#-------------------------t@CM----------------------------#
	if ($#file_list != -1){
		
		foreach $lib_a (keys(%mail_file)){
			
			($name,$type) = split(/:/,$lib_a);
			
			#---Content-TypeF
			if ($type eq ""){ ($type_data) = $name =~ /\.(\w+)$/;
			                  $type_data =~ tr/A-Z/a-z/;
			                  $type = $kakutyousi{$type_data};
			                                                     }
			if ($type eq ""){ $type = "application/octet-stream";}

			&main::jcode'convert(*name,"jis");
			$name = &main::mimeencode($name);
			
			#---wb_[M
			$header2  = "--$boundary_data\r\n";
			$header2 .= "Content-Type: $type\; name=\"$name\"\r\n";
			$header2 .= "Content-Disposition: attachment\; filename=\"$name\"\r\n";
			$header2 .= "Content-Transfer-Encoding: base64\r\n\r\n";
			
			&main::jcode'convert(*header2,"jis");
			&smtp_tr($header2);
			
			#---{fBM
			&smtp_tr(&main::bodyencode($mail_file{$lib_a}));
			&smtp_tr(&main::benflush());
			
			&smtp_tr("\r\n");
			
		}
		
	}
	
	#---I
	if ($boundary_data ne ""){ &smtp_tr("--$boundary_data--\r\n\r\n");}
	
	&smtp_tr(".\r\n");
	$rc = &smtp_rc();
	
	&execute("closesmtp");
	
	return (1,*output_sendstate);
	
}
