
#---SSL Connection
return 1;

sub open_ssl_connection{
	($host,$port,$net_sock) = @_;
	
	if ($main_ssl_flag == 0){
		($rc,$type,$msg) = &init_ssl();
		if ($rc ne "1"){ return('open_ssl_connection->'.$rc,$type,$msg);}
	}
	if ($main_ssl_flag == 1){
		
		($rc,$type,$msg) = &execute('open_tcp_connection',$host,$port,$net_sock);
		if ($rc ne "1"){ return('open_ssl_connection->'.$rc,$type,$msg);}
		
		$sock_hash{$net_sock."ctx"} = Net::SSLeay::CTX_new()                  || return('open_ssl_connection','ctx_new','Net::SSLeay');
		$sock_hash{$net_sock} = Net::SSLeay::new($sock_hash{$net_sock."ctx"}) || return('open_ssl_connection','ssl_new','Net::SSLeay');
		
		Net::SSLeay::set_fd($sock_hash{$net_sock}, fileno($net_sock));
		Net::SSLeay::connect($sock_hash{$net_sock}) || return('open_ssl_connection','ssl_con','Net::SSLeay');
		
		$sock_mode{$net_sock} = "1";
		
	}else{
		
		$sock_hash{$net_sock} = Net::SSL->new(
					     PeerAddr => $host,
					     PeerPort => $port,
					     Timeout => 15,
					     );
		$error = $@;
		$@ && return('open_ssl_connection','ssl_con','Crypt::SSLeay - '.'Host:'.$host."-".'Port:'.$port);
		$cert = $sock_hash{$net_sock}->get_peer_certificate;

		$sock_mode{$net_sock} = "2";

	}
	
	return(1);
}

