#-------------------------------------
# TuW[ - account_ctl_config 
#                                     
# Copyright 2005                      
# ---LunarNight Lab.---               
# lunar-night@ninus.ocn.ne.jp         
# http://www.age.jp/~lunar/           
#-------------------------------------

return 1;

sub account_ctl_config{
	my($mode,$mode2) = @_;
	
	my($opt,$dat_f,$title,$header,$fooder,$hidden,$bname,$utn) = ('','','','','','','','');
	my %in_hash=();

	if ($mode eq "login"){
		($dat_f) = &execute('account_ctl_getdef');
		*dat_p = $dat_f;
		%input_a = () if $dat_p{"use_ackey"} ne "1";
		
		$title  = $title_sign;
		$header = $header_sign."\n"."<right>Version$version</right>\n";
		$fooder = $copy_right;
		%in_hash= ('ac_login' => 1);
		$hidden = &make_hidden(\%in_hash);
		$bname  = 'OC';
		$utn    = '1' if $auth_mode eq '1';
		
		if ($use_slogin eq "1"){
			$opt  = '';
			$opt .= 'name,' if $def_username eq '';
			$opt .= 'mail,' if $def_mailaddr eq '';
			$opt .= 'user,pass,self';
		}elsif($use_slogin eq '2'){
			$opt  = 'user,pass,self';
		}else{
			if ($view_smtpauth eq '1'){
				$opt = 'name,mail,mserv,user,pass,mauth,hot,sserv,sauth,esmtp,pbs,self';
			}else{
				$opt = 'name,mail,mserv,user,pass,mauth,hot,sserv,sauth,self';
			}
		}
	}elsif($mode eq "account"){
		($dat_f) = &execute('account_ctl_getdef','1');
		$title  = 'Đݒ';
		$header = 'Đݒ';
		$fooder = $copy_right;
		%in_hash= ('ac_set' => 1,
		           'oldm'   => $mserv,
		           'oldu'   => $user,
		           'usr'    => $enc);
		$hidden = &make_hidden(\%in_hash);
		$bname  = 'ݒ';
		$utn    = '1' if $auth_mode eq '1';
		
		if ($use_slogin eq "1"){
			$opt  = "";
			$opt .= "name," if $def_username eq "";
			$opt .= "mail," if $def_mailaddr eq "";
			$opt .= 'user,pass,self';
		}elsif($use_slogin eq '2'){
			$opt  = 'user,pass,self';
		}else{
			if ($view_smtpauth eq '1'){
				$opt = 'name,mail,mserv,user,pass,mauth,hot,sserv,sauth,esmtp,pbs,self';
			}else{
				$opt = 'name,mail,mserv,user,pass,mauth,hot,sserv,sauth,self';
			}
		}
	}elsif($mode eq "option"){
		($dat_f) = &execute('account_ctl_getdef','1');
		my $setopt_p = "";
		
		if   ($mode2 eq 'imap'){ $opt = 'dspm,itree,imap,scan';                                         $title = $header = 'ڍאݒ - IMAP'; $setopt_p = 'ac_setopt';}
		elsif($mode2 eq 'smtp'){ $opt = 'esmtp,pbs';                                                    $title = $header = 'ڍאݒ - SMTP'; $setopt_p = 'ac_set2';  }
		else                   { $opt = 'mchk,ackey,chks,dconf,nconf,mconf,head,shead,link,linem,addrc';$title = $header = 'ڍאݒ';        $setopt_p = 'ac_setopt';}
		$fooder = $copy_right;
		%in_hash= ($setopt_p   => 1,
		           'id'        => $agent_id,
		           'set_mode'  => $mode2,
		           'usr'       => $enc);
		$hidden = &make_hidden(\%in_hash);
		$bname  = 'ݒ';
		
	}elsif($mode eq "conf"){
		$title  = 'ݒ胁j[';
		$header = 'ݒ胁j[';
		$fooder = $copy_right;
		%in_hash= ('dsp_main' => 1,
		           'usr'      => $enc,
		           'id'       => $agent_id);
		$hidden = &make_hidden(\%in_hash);
		$bname  = '߂';
		
		$opt = 'conf';
	}elsif($mode eq "save"){
		
		$title  = "$name - $mserv";
		$title  = $title_sign if $mserv eq "";
		$header = $header_sign;
		$fooder = $copy_right;
		$utn    = '1' if $auth_mode eq '1';
		%in_hash= ('ac_relogin' => 1,
		           'usr'        => $enc);
		$hidden = &make_hidden(\%in_hash);
		$bname  = '';
		
		$opt = 'save,chkm,mlist,savec';
	}elsif($mode eq "save2"){
		
		($rand_seed) = &execute('get_randseed');
		$crypt_seed  = '';
		$crypt_seed  = $ENV{'SCRIPT_NAME'} if $fixed_mode eq '1';
		$crypt_seed .= $ENV{'HTTP_USER_AGENT'} if $auth_mode ne '1';
		$crypt_seed .= $rand_seed;
		&encrypt('set_pass',$crypt_seed);

		my $pass = &md5'convert($enc.time());
		my $dat  = pack('CCCC',length($sid),length($mserv),length($user),length($pass));
		($rc,$enc3) = &encrypt('encrypt',$dat.$sid.$mserv.$user.$pass,'b64');
		
		&encrypt('set_pass',$pass);
		($rc,$dat) = &encrypt('encrypt',$enc,'b64');
		($rc,$msg) = &execute('account_sub_sidctl','set',$sid,'euc',$dat);
		if ($rc ne '1'){ &error('SID_Error','save2->'.$msg);}
		
		$title  = "$name - $mserv";
		$title  = $title_sign if $mserv eq "";
		$header = $header_sign;
		$fooder = $copy_right;
		%in_hash= ('dsp_main' => 1,
		           'usr'      => $enc,
		           'id'       => $agent_id);
		$hidden = &make_hidden(\%in_hash);
		$bname  = '';
		
		$opt = 'save,save2';
	}elsif($mode eq "save3"){
		
		(*crypt_p)   = &encrypt('backup');
		@back_data   = @crypt_p;
		
		($rand_seed) = &execute('get_randseed');
		$crypt_seed  = '';
		$crypt_seed  = $ENV{'SCRIPT_NAME'} if $fixed_mode eq '1';
		$crypt_seed .= $ENV{'HTTP_USER_AGENT'} if $auth_mode ne '1';
		$crypt_seed .= $rand_seed;
		&encrypt('set_pass',$crypt_seed);
	
		my($rc,$dec) = &encrypt('decrypt',$in{'enc'},'b64');
		if ($rc ne "1"){
			&error('Save3-1','Ɏs܂',$in{'enc'});
		}
		
		my($sid_l,$mserv_l,$user_l,$pass_l) = unpack('CCCC',substr($dec,0,4));
		$sid   = substr($dec,4,$sid_l);
		$mserv = substr($dec,4+$sid_l,$mserv_l);
		$user  = substr($dec,4+$sid_l+$mserv_l,$user_l);
		$pass  = substr($dec,4+$sid_l+$mserv_l+$user_l,$pass_l);
		($rc,$dat) = &execute('account_sub_sidctl','get',$sid,'euc');
		if ($rc ne '1'){ &error('SID_Error','save3->'.$dat."-".$sid."-".$mserv."-".$user."-".$pass);}
		
		&encrypt('set_pass',$pass);
		my($rc,$enc) = &encrypt('decrypt',$dat,'b64');
		if ($rc ne "1"){ &error('Save3-2','Ɏs܂',$dat);}
		
		&encrypt('restore',*back_data);
		&execute('account_ctl_get',$enc,'1');
		
		$title  = "$name - $mserv";
		$title  = $title_sign if $mserv eq "";
		$header = $header_sign;
		$fooder = $copy_right;
		$utn    = '1' if $auth_mode eq '1';
		%in_hash= ('ac_relogin' => 1,
		           'usr'        => $enc,
		           'id'         => $agent_id);
		$hidden = &make_hidden(\%in_hash);
		$bname  = '';
		
		$opt = 'save,chkm,mlist';
	}else{ &error('SystemError','sȃ[hł:'.$mode);}
	
	return(&execute('dsp_config',$title,$header,$fooder,$hidden,$bname,$dat_f,$opt,$utn));
}
