#----------------------------------
# TuW[ - account_ctl_set 
#                                  
# Copyright 2005                   
# ---LunarNight Lab.---            
# lunar-night@ninus.ocn.ne.jp      
# http://www.age.jp/~lunar/        
#----------------------------------

return 1;

sub account_ctl_set{
	my($sid,$setflag) = @_;
	#---VAID擾
	($sid) = &execute('sys_minidb','newrec',$minidb_rec,$minidb_name) if $sid eq "";
	
	if ($setflag eq '1'){
		my $a;
		foreach $a (@flag_bit){
			$a =~ tr/ //d;
			my($key,$offset,$mod,$def,$val) = split(/:/,$a);
			$in{$key} = $$key;
		}
		foreach $a (@account_data){
			my($key,$opt) = split(/:/,$a);
			$in{$key} = $$key;
		}
	}
	my $setaccept = 'all';
	if ($use_slogin eq '1'){
		$setaccept = 'name mail user pass';
	}elsif($use_slogin eq '2'){
		$setaccept = 'user pass';
	}
	
	return(&account_ctl_setfromstdin($sid,$setaccept));
	
}

sub account_ctl_setfromstdin{
	my($sid,$setaccept) = @_;
	
	#---tOnf[^i[
	my $flags = '';
	my $a;
	my $b;
	foreach $a (@flag_bit){
		$a =~ tr/ //d;
		my($key,$offset,$mod,$def,$val) = split(/:/,$a);
		my $dat = '';
		my $set = '';
		
		$dat = $in{$key};
		$$key = $dat;
		foreach $b (split(/,/,$val)){
			my ($k,$v) = split(/=/,$b);
			if (index($dat,$k) != -1){ $set = $set | $v;}
		}
		if ($set eq ""){ $set = $def;}
		$flags .= $set;
	}
	my $str2 = pack('B*',$flags.$padding[length($flags)%8]);
	
	#---nf[^i[
	my $str3 = "$sid\0";
	my $str4 = "$sid\0";
	foreach $a (@account_data){
		my($key,$opt) = split(/:/,$a);
		my $dat;
		$dat = $in{$key};
		$$key  = $dat;
		if ($setaccept eq 'all' || index($setaccept,$key) != -1){
			$str3 .= $dat;
			$str4 .= $dat if $key ne 'pass';
		}
		$str3 .= "\0";
		$str4 .= "\0";
	}
	my $str_e = pack('CC',length($str2),length($str3)).$str2.$str3;
	my $str_t = pack('CC',length($str2),length($str4)).$str2.$str4;
	
	#---ftHgf[^`FbN
	&account_defchk();
	&account_datachk(@account_data);

	#---G[`FbN
	my $flag1=0;
	my $flag2=0;
	foreach (split(/\n/,$server_list)){
		if ($_ eq ""){ next;}
		$flag1=1 if $_ eq $mserv;
		$flag2=1;
	}
	if ($flag2 == 1 && $flag1 == 0 && $use_slogin eq "0"){ 
		&error('bad_user','ڑ悪sł:'.$mserv);
	}
	&error('CID_Error','gьŗLԍ܂') if $agent_id eq "" && $auth_mode eq "1";
	
	#---[U[`FbN
	my($rc) = &execute('access_ctl','check',$user);
	if ($rc eq "0"){ &error('bad_user',$user);}
	
	#---OC`FbN
	&execute('login');
	
	#---OC
	my $oldm = $in{'oldm'};
	my $oldu = $in{'oldu'};
	$mserv = "Hotmail" if $mauth eq "h";
	&execute('access_ctl','access',$sid,$user,$mserv,$oldm,$oldu);
	
	($res,$str_e) = &encrypt('encrypt',$str_e,'b64');
	($res,$str_t) = &encrypt('encrypt',$str_t,'b64');
	
	#---O
	$in{'dsp_main'} = '1';

	return($str_e,$str_t,$sid);
	
	
}

