
#-------------------------------------------------------------------------------#
#               WebMailClient2 for Keitai F؃W[|AJEg        #
#                                                                               #
# Copyright 2004                                                                #
# ---LunarNight Lab.---                                                         #
# lunar-night@par.odn.ne.jp                                                     #
# http://www.age.jp/~lunar/                                                     #
#-------------------------------------------------------------------------------#

@string_set  = ('name','mail','mserv:s','user','pass','smtp:s','imap_inbox:s');
@value_set   = ('body_maxstr:dl','dsp_maxlist:d','page_group:d','matrix_x:d','matrix_y:d','subj_maxstr:d','from_maxstr:d');
@flag_set    = ('mauth','mssl:s','sauth','sssl:s','dsp_opt:d','dsp_treetype:d','imapscanmode:sd','selfsend:s','chkinbox:s');
@flag_bit    = ('mauth       :2:eq:00     :p=00,a=01,i=10,h=11',
                'mssl        :1:eq:0      :1=1',
                'sauth       :3:eq:000    :n=000,p=001,b=010,m=011,s=100',
                'sssl        :1:eq:0      :1=1',
                'dsp_opt     :7:or:0000000:f=0000001,t=0000010,c=0000100,n=0001000,d=0010000,s=0100000,i=1000000',
                'dsp_treetype:2:eq:00     :0=00,1=01,2=10,3=11',
                'imapscanmode:2:eq:00     :0=01,2=10,1=00,3=11',
                'selfsend    :1:eq:0      :1=1',
                'chkinbox    :2:eq:00     :1=01,0=10');
@padding = ('','0000000','000000','00000','0000','000','00','0'.'');
%def_data_h  = ('imap_inbox' => 'INBOX');

%name_hash   = ('name'  => 'O'        ,
                'mail'  => 'Ұٱڽ'    ,
                'mserv' => 'Ұٻް'    ,
                'user'  => 'Ұհް'  ,
                'pass'  => 'Ұ߽ܰ'  ,
                'mauth' => 'ҰٔF' ,
                'smtp'  => 'SMTPް'   ,
                'sssl'  => 'SMTP overSSL',
                'mssl'  => 'Mail overSSL',
                'sauth' => 'SMTPF' );

return 1;

sub rap_oldlogin2{
	my($usr) = @_;
	
	#---ۑmF
	if ($in{'seed'} ne ""){
		$rand_seed = $in{'seed'};
		#---
		($usr) = &execute('passctl','get',$rand_seed);
	}
	&account('get',$usr,1);
	
	if   ($in{'dsp_save' } ne ''){ &execute('dsp_save' ); exit;}
	elsif($in{'dsp_save2'} ne ''){ &execute('dsp_save2'); exit;}
	elsif($in{'dsp_save3'} ne ''){ &execute('dsp_save3'); exit;}
	else{
		&load_lib($lib_md5);
		&execute('account_ctl_log','re');
		my $tmp_str = $mserv.$user.$pass.$mail.$name;
		$tmp_str = unpack('H*',&md5'convert($tmp_str));
		($rc,$sid) = &execute('sid_search',$auth_folder,'oldlogin',$tmp_str);
		if ($rc eq '0'){
			($sid) = &execute('sys_minidb','newrec',$minidb_rec,$minidb_name);
			($rc,$dat) = &execute('account_sub_sidctl','init',$sid);
			if ($rc ne "1"){ &error('SID_Error','init->'.$dat);}
			($rc,$dat) = &execute('account_sub_sidctl','set',$sid,'oldlogin',$tmp_str);
			if ($rc ne "1"){ &error('SID_Error','set->'.$dat);}
		}
		$in{'dsp_main'} = '1';
		($enc,$enc2,$sid) = &execute('account_ctl_set',$sid,'1');
		&execute('account_ctl_setopt','1');
		return($enc,$enc2,$sid);
	}
}

sub account{
	
	($mode,$point,$chk) = @_;
	
	#---_V[h擾
	($rand_seed) = &execute('get_randseed');
	
	#---ÍV[hݒ
	$crypt_seed  = $ENV{'SCRIPT_NAME'};
	$crypt_seed .= $ENV{'HTTP_USER_AGENT'} if $auth_mode ne "1";
	$crypt_seed .= $rand_seed;
	$crypt_seed .= $cid if $auth_mode eq "1";
	&encrypt('set_pass',$crypt_seed);
	
	if  ($mode eq 'get' ){ return(&account_get($point,$chk));  }
	else                 { &error('AccountError','sȺނł',$mode);}
	
}


#---ϐ
sub initver{
	foreach $a (@value_set,@string_set,@flag_set){
		($key,$opt) = split(/:/);
		$$key = "";
	}
}

#---AJEgf[^`FbN
sub account_datachk{
	$err = "";
	if ($in{'dsp_save' } ne '' ||
	    $in{'dsp_save2'} ne '' ||
	    $in{'dsp_save3'} ne ''   ){ return(1);}
	#---G[`FbN
	foreach $a (@value_set,@flag_set,@string_set){
		($key,$opt) = split(/:/,$a);
		if ($$key     eq '' &&
		    $in{$key} eq '' &&
		    index($opt,'s') == -1   ){ $err .= ':'.$key.':'.$name_hash{$key}."\n";}
	}
	&error("no_item" ,$err ) if $err ne "";
}

#---AJEgftHg`FbN
sub account_defchk{
	#---bp[
	if($use_slogin eq "1"){
		&execute('rap_slogin');
	}elsif($use_slogin eq '2'){
		&execute('rap_slogin2');
	}
	foreach $a (@value_set,@flag_set,@string_set){
		($key,$opt) = split(/:/,$a);
		if ($$key eq "" && index($opt,"d") != -1){
			$tmp = "def_".$key;
			$$key= $$tmp;
		}
	}
	while(($key,$val) = each %def_data_h){
		if ($$key eq ""){ $$key = $val;}
	}
}

#---10i2iϊ
sub dec2bin($){
  local($_,$s) = @_;
  local($result);
  do {
    $result = ($_ & 1).$result;
    $_ >>= 1;
  } while($_);
  if   (length($result) >  16 && $s == 2){ $result = "1111111111111111";      }
  elsif(length($result) >  8  && $s == 1){ $result = "11111111";              }
  elsif(length($result) <= 8  && $s == 2){ $result = "00000000".$result;      }
  $result = $padding[length($result)%8].$result;
  return $result;
}
sub bin2dec($){
  local($_) = @_;
  local($result);
  foreach ( split(//,$_) ){
    $result += ($_ & 1);
    $result *= 2;
  }
  $result /= 2;
  return $result;
}

#-------------------------------
# TuW[ - account_get 
#                               
# Copyright 2004                
# ---LunarNight Lab.---         
# lunar-night@ninus.ocn.ne.jp   
# http://www.age.jp/~lunar/     
#-------------------------------

sub account_get{
	
	($enc,$chk) = @_;
	
	&initver(); #---ϐ
	
	($res,$str) = &encrypt('decrypt',$enc,'b64');
	if ($res ne "1" && $chk eq ""){ &error('GetAccountError','Ɏs܂',$enc);}
	
	$val_size = unpack('C',substr($str,0,1));
	$bin_size = unpack('C',substr($str,1,1));
	$str_size = unpack('C',substr($str,2,1));
	
	#---o[W`FbN
	if ($val_size+$bin_size+$str_size+ 3 != length($str)){
		
		&execute('rap_oldaccount','get',$str);
		
	}else{
		$val_str  = unpack('B*',substr($str,3,$val_size));
		$bin_str  = unpack('B*',substr($str,3+$val_size,$bin_size));
		$str2     = substr($str,3+$bin_size+$val_size,$str_size);
		
		#---lnf[^
		foreach $a (@value_set){
			($key,$opt) = split(/:/,$a);
			if (index($opt,"l")  !=  -1){ $bin = substr($val_str,0,16); substr($val_str,0,16) = "";}
			else                        { $bin = substr($val_str,0,8 ); substr($val_str,0,8 ) = "";}
			if (substr($bin,0,1) eq "1"){ substr($bin,0,1) = "0";       $$key = &bin2dec($bin);    }
			else                            {                           $$key = "";                }
			if ($val_str eq ""){ last;}
		}
	
		
		#---tOnf[^
		foreach $a (@flag_bit){
			$a =~ tr/ //d;
			($key,$offset,$mod,$def,$val) = split(/:/,$a);
			$dat = substr($bin_str,0,$offset);
			$set = "";
			foreach $b (split(/,/,$val)){
				($k,$v) = split(/=/,$b);
				if ($mod eq "eq"){
					if ($dat        eq $v){ $set .= $k;}
				}else{
					if (($dat & $v) eq $v){ $set .= $k;}
				}
			}
			$$key = $set;
			substr($bin_str,0,$offset) = "";
			if ($bin_str eq ""){ last;}
		}
		
		#---nf[^
		@item = split(/\0/,$str2);
		$cnt  =0;
		foreach $a (@string_set){
			($key,$opt) = split(/:/,$a);
			$$key = $item[$cnt];
			$cnt++;
		}
	}
	#---ftHg`FbN
	&account_defchk();
	&account_datachk();
	
	#---eG[`FbN
	($res) = &execute('access_ctl','check',$user);
	if ($res eq "0"){ &error("bad_user",$user);}
	$mserv = "Hotmail" if $mauth eq "h";
	
	
}
