#-------------------------------------------------------------------------------#
#               WebMailClient2 for Keitai sW[|[U[`      #
#                                                                               #
# Copyright 2006                                                                #
# ---LunarNight Lab.---                                                         #
# lunar@ln-lab.net                                                              #
# http://www.ln-lab.net/                                                        #
#-------------------------------------------------------------------------------#

&load_lib($lib_md5);
&load_lib($lib_des);
&load_lib($lib_crypt);
return 1;

sub userdef_ctl{
	my($mode,@opt) = @_;

	open(LOCK,">".$conf_dir."userdef_lock.dat");
	flock(LOCK,2);
	
	my $usefile = $auth_folder."userdef_list.dat";

	(*crypt_p)   = &encrypt('backup');
	@back_data   = @crypt_p;
	
	my($rand_seed) = &execute('get_randseed');
	&encrypt('set_pass',$rand_seed);
	
	my @res = ();
	if   ($mode eq 'set' ){ @res = &userdef_set ($usefile,@opt);}
	elsif($mode eq 'get' ){ @res = &userdef_get ($usefile,@opt);}
	elsif($mode eq 'list'){ @res = &userdef_list($usefile);     }
	else{ &error('SystemError','sȃR}hł',$mode);}
	
	flock(LOCK,8);
	close(LOCK);

	&encrypt('restore',\@back_data);
	
	return(@res);
}

sub userdef_get{
	my($usefile,$key,$pass) = @_;
	
	my $out = '';
	open(DATA,$usefile);
	while(<DATA>){
		my($okey,$val) = split(/:/,$_);
		if ($okey eq $key){
			my($rc,$dat) = &encrypt('decrypt',$val);
			next if $dat eq '';
			$out = $dat;
			last;
		}
	}
	close(DATA);
	
	if ($out eq ''){ return('');}
	else{ 
		my @item = split(/\0/,$out);
		if ($item[0] eq $pass){
			return($key,@item);
		}else{
			shift(@item);
			shift(@item);
			shift(@item);
			return($key,'','','',@item);
		}
	}
	
}

sub userdef_list{
	my($usefile) = @_;
	
	my $out = '';
	open(DATA,$usefile);
	while(<DATA>){
		next if $_ eq '';
		
		my($key,$val) = split(/:/,$_);
		my($rc,$dat) = &encrypt('decrypt',$val);
		next if $dat eq '';
		$dat =~ tr/\0/:/;
		$out .= $key.":".$dat."\n";
	}
	close(DATA);
	
	return($out);
}

sub userdef_set{
	my($usefile,$userdef) = @_;

	my $a;
	my $write;
	open(DATA,">".$usefile);
	foreach $a (split(/\n/,$userdef)){
		$a =~ tr/\r//d;
		my($user,$pass,$muser,$mpass,$mail,$handle) = split(/\s*:\s*/,$a);
		my($rc,$tmp) = &encrypt('encrypt',$pass."\0".$muser."\0".$mpass."\0".$mail."\0".$handle."\0");
		
		print DATA $user.":".$tmp.":"."\n";
	}
	close(DATA);
	
	return(1);
}
