#-------------------------------------------------------------------------------#
#          QRR[hBookmarko^C[Wo̓W[                           #
#                                                                               #
# Copyright 2002-2003                                                           #
# ---LunarNight Lab.---                                                         #
# lunar-night@ninus.ocn.ne.jp                                                   #
# http://www.age.jp/~lunar/                                                     #
#-------------------------------------------------------------------------------#

return 1;

sub qr_mkbookmark{
	
	($url,$title,$mkname,$imgtype,$size) = @_;
	
	if ($img_type eq "jpg"){$type = "jpg";}
	else                   {$type = "png";}
	
	#---QRR[h
	$str   = "MEBKM:TITLE:$title;URL:$url;;";
	$chstr = "MEBKM:TITLE:$title;URL:$url;;\0$size\0$imgtype";
	
	#---LbV`FbN
	($rc,$opt) = &qr_mkbookmark_chk($chstr,$mkname,$type);
	if ($rc eq '1' || $rc ne '2'){ return($rc,$opt);}
	
	#---QRR[h쐬
	($rc,$opt) = &qr_mkbookmark_mk($str,$chstr,$mkname,$type,$size);
	if ($rc ne '1'){ return($rc,$opt);}
	
	return('1',$opt);
	
}

#---QRR[h쐬
sub qr_mkbookmark_mk{
	($str,$chstr,$mkname,$type,$size) = @_;
	
	$use_file = $conf_dir.$mkname.".".$type.".dat";
	$img_file = $conf_dir.$mkname.".".$type;
	$size     = "2" if $size eq "";
	
	#---QRImageǂݍ
	if (! -e $make_qr_path){ return('0',&qr_mkbookmark_err($type));}
	&load_lib($make_qr_path);
	
	#---QRR[h쐬
	($rc,*qr_p) = &make_qr($str,'H',$size,$type,$make_qr_path);
	if ($rc eq "1"){
		open(IN,">".$use_file);
		print IN $chstr;
		close(IN);
	}
	
	open(IN,">".$img_file);
	binmode IN;
	print IN $qr_p;
	close(IN);
	
	return('1',$img_file);
}

#---QRR[hLbV`FbN
sub qr_mkbookmark_chk{
	($chstr,$mkname,$type) = @_;
	
	$use_file = $conf_dir.$mkname.".".$type.".dat";
	$img_file = $conf_dir.$mkname.".".$type;
	
	open(IN,$use_file);
	$org_str = <IN>;
	close(IN);
	
	if ($org_str eq $chstr){ return('1',$img_file);}
	else                   { return('2');          }
	
}

sub qr_mkbookmark_err{
	($type) = @_;
	
	$err_png = '
iVBORw0KGgoAAAANSUhEUgAAAHIAAAAfCAIAAAC01Q6uAAAAAXNSR0IArs4c6QAAAARnQU1B
AACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAA
AcFJREFUaEPtmW2TgjAMhPH//2jOO286IS/bRVkYNYwfUNukebKNKd7WdV36OpzAHevvtSz+
hT8HU+LEfx/QkR3z/vfLBmuM54F7XPYt+RUYNnLz/hxdBAKsjqNjhyl/Ct/GKsnkFuuosG7X
28o7/YpRa2pQEuA1Rveo9bliCopATMA1EI73ugcrWSUZtaa/gcdHd5lFAVaSvu3DLgtf5bio
raOpAtJjVInHfC5Z05OqMveNdhurJOuNVY216iWZxwWStRmjr5zNpD1ycZrPOgH+FH9a4+nO
KVO/r6RhV/OHsDK/6czTFp1mvxdrrBXx0VcqohQZGJn2xVE1qY7cItODuG37sNm6Q/8rAoxa
0wpVeQXlbEyJN9Nj7nNzrVmbwl0LsBux2PgWI401bd2BIoCmHipOhRMl7/y6hBERbnRDjgfB
gnJkjG+xThM4FVSURjUlbpF038QIU8WBhaVLir4cLybSSRGotgmvUEyTL3OMmg7Hyjutchw+
D3+oxLJYVd5qPwLJ80ScU/C2quNuGTiuqRFctRBWW5XPua+COce70ksfXiV0G2tjlRCQGG21
NlYJAYnRVmtjlRCQGG21SrD+AFtg9+fnpPbvAAAAAElFTkSuQmCC
';
	$err_jpg = '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';
	
	&load_lib($lib_mimer);
	$err_jpg =~ tr/\r//d;
	$err_png =~ tr/\r//d;
	if (!-e $conf_dir."error.jpg"){
		open(IN,">".$conf_dir."error.jpg");
		binmode IN;
		print IN &bodydecode($err_jpg);
		close(IN);
	}
	if (!-e $conf_dir."error.png"){
		open(IN,">".$conf_dir."error.png");
		binmode IN;
		print IN &bodydecode($err_png);
		close(IN);
	}
	
	if ($type eq 'jpg'){ return($conf_dir."error.jpg");}
	else               { return($conf_dir."error.png");}
	
}
